function r_v = baseline_prediction(mu,bu,bi,user_v,item_v)
% baseline prediction, for user u and item i, the prediction for the rating
%   is r_u,i = mu+bu(u)+bi(i)
% Inputs:
% bu, bi: two column vectors accounts for the user effects and item_v
%   effects;
% mu: a scalar indicating the whole average rating;
% user_v, item_v: two column vectors with the same length containing the
%   indices of user_v and item_v to be predicted;  E.g. user_v = [40 3 2]';
%   item_v = [1 90 2]' impling to predict entry (40 1), (3 90) and (2 2);
% Outputs:
% r_v : a column vector with the same length as the Input USERS, containg
%   the predicted ratings;

testSize = length(user_v);
r_v = zeros(testSize,1);
for ii=1:testSize    
    r_v(ii) = mu + bu(user_v(ii)) + bi(item_v(ii));
end