function main_baseline()
% main file for baseline prediction

% database = 'ua';
% trainFile = sprintf('../data/%s_train_quiz.mat',database);
% testFile = sprintf('../data/%s_test.mat',database);
% load(trainFile,'Train','Quiz');
% load(testFile,'Test');

database = 'eachmovie';
dataFile = sprintf('../data/%s_sub.mat',database);
load(dataFile,'Train','Test','Quiz');

BETA = 0;

% load the training results for bu and bi;
%trainFile = '../iteration/MatrixFactorization/MatrixFactorizationCF03-Jan-2011MAE-7356.mat';
trainFile = '../iteration/MatrixFactorization/MatrixFactorizationCF_eachmovie_SVD_gamma3_0.010_25-Jan-2013.mat';

load(trainFile,'bu','bi','mu');

TestSet = {'Test','Quiz'};
for ii=1:length(TestSet)
    %  predict the given entries
    Set = TestSet{ii};
    [user_v item_v] = find(eval(Set)~=BETA);
    r_v = baseline_prediction(mu,bu,bi,user_v,item_v);

    %  calculate the predict precision
    [MAE acc1 acc2 BadEntryRate  ErrorRate] = indicator_precision(user_v,item_v,r_v,eval(Set),BETA);

    %  put out the result to mat file and command window
    resultFile_mat = sprintf('../result/result_baseline_%s_%s.mat',database,Set);
    save(resultFile_mat,'user_v','item_v','r_v','MAE','acc1','acc2','BadEntryRate','ErrorRate');
    putoutResult();
end

    function putoutResult()
        for id = 1
            fwritef(id,'database',database,'%s');
            fprintf(id,'test Set\t%s\n',Set);
            fprintf(id,'# tested entries\t%d\n',nnz(eval(Set)));
            fwritef(id,'MAE',MAE,'%.4f','acc1',acc1*100,'%.2f %%', 'acc2',acc2*100,'%.2f %%');
            fwritef(id,'BadEntryRate',BadEntryRate*100,'%.2f %%', 'ErrorRate',ErrorRate*100,'%.2f %%');            
        end
    end
end