function main_user_item_mean()
% main file for user_mean_prediction and item_mean_prediction

% database = 'ua';
% trainFile = sprintf('../data/%s_train_quiz.mat',database);
% testFile = sprintf('../data/%s_test.mat',database);
% load(trainFile,'Train','Quiz');
% load(testFile,'Test');

database = 'eachmovie';
dataFile = sprintf('../data/%s_sub.mat',database);
load(dataFile,'Train','Test','Quiz');


BETA = 0;

% infFile_train = 'ua_train_inf.mat';
infFile_train = sprintf('../iteration/%s_train_inf.mat',database);
load(infFile_train,'ave_rating_user','ave_rating_item');

TestSet = {'Test','Quiz'};
dirs = {'user','item'};
for i_dir = 1:length(dirs)
    dir = dirs{i_dir};
    for ii=1:length(TestSet)
        %  predict the given entries
        Set = TestSet{ii};
        [user_v item_v] = find(eval(Set)~=BETA);
        r_v = eval(sprintf('%s_mean_prediction(%s_v,ave_rating_%s)',dir,dir,dir));
        %  calculate the predict precision
        [MAE acc1 acc2 BadEntryRate  ErrorRate] = indicator_precision(user_v,item_v,r_v,eval(Set),BETA);
        %  put out the result to mat file and command window
        resultFile_mat = sprintf('../result/result_%s_%sMean_%s.mat',database,dir,Set);
        save(resultFile_mat,'user_v','item_v','r_v','MAE','acc1','acc2','BadEntryRate','ErrorRate');
        putoutResult();
    end
end
    function putoutResult()
        for id = 1
            fwritef(id,'database',database,'%s');
            fprintf(id,'test Set\t%s\n',Set);
            fprintf(id,'# tested entries\t%d\n',nnz(eval(Set)));
            fwritef(id,'MAE',MAE,'%.4f','acc1',acc1*100,'%.2f %%', 'acc2',acc2*100,'%.2f %%');
            fwritef(id,'BadEntryRate',BadEntryRate*100,'%.2f %%', 'ErrorRate',ErrorRate*100,'%.2f %%');            
        end
    end
end