function modelSelectionDecomposition()
% select parameters for matrix decompostion 
% database = 'ua';
% trainFile = sprintf('../data/%s.base',database);
% testFile = sprintf('../data/%s.test',database);
% BETA = 100;
%  
% 
% R = readData(trainFile,BETA);   % rating matrix
% Test = readData(testFile,BETA);    % tested matrix

database = 'eachmovie';
dataFile = sprintf('../data/%s_sub.mat',database);
s=load(dataFile,'Train','Test','Quiz');
Train = s.Train;
Test = s.Test;
%Quiz = s.Quiz;
BETA = 0;

[user_v item_v] = find(Test~=BETA);

% 0. Set parameters for the algorithm
opt=struct();
opt.lambda_6 = 0.005; 
opt.lambda_7 = .01;%0.045; %0.005;
opt.lambda_8 = 0.020;
  % step size 
opt.gamma_1 = 0.007;
opt.gamma_2 =  .01; %0.06; %0.007;%%%
opt.gamma_3 = 0.01;
opt.sigma = 0.95; % decreasing scalar for step size
opt.alpha = 0.70; % the role of nearest neighbors
opt.nNbr = 400;  %%%   % neighborhood size
opt.nf = 8; %10; % factor space dimension
opt.ite_num = 4; %5; % iteration number
opt.threshold = opt.nNbr;  % threshold
  % similarity file containing similarities between items
opt.similarityFile = '../iteration/similarity_item_train_eachmovie.mat';
opt.verbose = 1;
opt.classicalSVD = 0; %1;

resultFile = sprintf('../result/modelSelectionDecomposition_%s_%s',database,datestr(date));
resultFile_xls = sprintf('%s.xls',resultFile);
resultFile_mat = sprintf('%s.mat',resultFile);

ii  = 0;
min_MAE = [];

%lambda_7_v = [.008 .012 .03];
%gamma_2_v = [0.003 .008 .012 .03 .06];

% lambda_7_v = [.04 .08];
% gamma_2_v = [.06 .10];

% lambda_7_v = [.045 .05 .055 .06 .065];
% gamma_2_v = [.06 .065 .07 .075];


%lambda_7_v = [ .01  .002];
%gamma_2_v = [.005  .001];

lambda_7_v = [.0008 .003];
gamma_2_v = [.01 .005];


%lambda_7_v = opt.lambda_7;
%gamma_2_v = opt.gamma_2;


% lambda_6_v = [0.003 0.012 .05];
% gamma_1_v = [0.004  0.01  .06];
lambda_6_v = opt.lambda_6;
gamma_1_v = opt.gamma_1;

%lambda_8_v = [.005 .02];
%gamma_3_v = [.001 .004];

lambda_8_v = [.0008 .003 .01];
gamma_3_v = [4.0E-6 2.0E-5 .0001];


len_lambda_7_v = length(lambda_7_v);
len_gamma_2_v = length(gamma_2_v);
len_acc = len_lambda_7_v * len_gamma_2_v;

% acc_c = cell(len_lambda_7_v,len_gamma_2_v);
% opt_c = cell(len_lambda_7_v,len_gamma_2_v);

Acc = zeros(len_acc,6);
Opt_mat = cell(len_acc,1);

ii = 0;
for lambda_6 = lambda_6_v %[0.005]
    for i_lambda_7 = 1:len_lambda_7_v
        for lambda_8 = lambda_8_v 
           for gamma_1  = gamma_1_v %[0.007]
             for i_gamma_2 = 1:len_gamma_2_v
                for gamma_3  = gamma_3_v

              lambda_7 = lambda_7_v(i_lambda_7);
              gamma_2 = gamma_2_v(i_gamma_2);              
              ii = ii+1;
              opt.lambda_6 = lambda_6;
              opt.lambda_7 = lambda_7;
              opt.lambda_8 = lambda_8;
              opt.gamma_1 = gamma_1;
              opt.gamma_2 = gamma_2;
              opt.gamma_3 = gamma_3;
%               % 1. train the parameters of the model  
%               trainFileName = sprintf('../iteration/MatrixDecompositionCF_%s_%d_%d_%s.mat',...
%                   database,i_lambda_7,i_gamma_2,datestr(now,1)); %%%%
%               tic;    
%                    matrixFactorizationCF_sparse(Train,trainFileName,opt);                   
%               train_time = toc;               
%               % 2. predict the entries of the test set
%               r_v = predictTestSet(trainFileName,user_v,item_v);
%               % 3. calculate the predict precision
%               [MAE acc1 acc2 BadEntryRate  ErrorRate] = indicator_precision(user_v,item_v,r_v,Test,BETA);
% 
%               Acc(ii,:) = [MAE acc1 acc2 BadEntryRate  ErrorRate train_time];
              Opt_mat{ii} = opt;
               end
             end 
          end
       end
    end
end

len_opt_mat = length(Opt_mat);
Acc = zeros(len_opt_mat,6);
matlabpool open
parfor ii=1:len_opt_mat
    opt= Opt_mat{ii};
    % 1. train the parameters of the model
    trainFileName = sprintf('../iteration/MatrixDecompositionCF_%s_%d_%s.mat',...
        database,ii,datestr(now,1)); %%%%
    tic;
    matrixFactorizationCF_sparse(Train,trainFileName,opt);
    train_time = toc;
    % 2. predict the entries of the test set
    r_v = predictTestSet(trainFileName,user_v,item_v);
    % 3. calculate the predict precision
    [MAE acc1 acc2 BadEntryRate  ErrorRate] = indicator_precision(user_v,item_v,r_v,Test,BETA);
    Acc(ii,:) = [MAE acc1 acc2 BadEntryRate  ErrorRate train_time];
end
matlabpool close;        


[min_MAE min_MAE_id]= min(Acc(:,1));
save(resultFile_mat,'Acc','Opt_mat','min_MAE','min_MAE_id');

    function putoutResult()
        % 1. put out the results to xls file 
        if ii<=1 % the first time to call this function
            % write the headline            
            %E = {'lambda_6','lambda_7','lambda_8','gamma_1','gamma_2','gamma_3','sigma','nNbr','nf','ite_num','threshold',...
            B2 = fieldnames(opt)';
            M2  = {'MAE','acc1','acc2','BanEntryRate','ErrorRate','train time'};
            xlswrite(resultFile_xls,B2,'B2:M2');
            xlswrite(resultFile_xls,M2,'N2:S2');
            xlswrite(resultFile_xls,{'minimal_MAE'},'B1:B1');
            xlswrite(resultFile_xls,{'ID_minimal_MAE'},'D1:D1');
        end
            % write the value of the parameters of the algorithm and  prediction accuracy
        range_A = sprintf('A%d:A%d',ii+2,ii+2);
        range_B = sprintf('B%d:M%d',ii+2,ii+2);
        range_M = sprintf('N%d:S%d',ii+2,ii+2);
        accuracy = [MAE acc1 acc2 BadEntryRate ErrorRate train_time];
        xlswrite(resultFile_xls,ii,range_A);               % index
        xlswrite(resultFile_xls,struct2cell(opt)',range_B);% parameter values
        xlswrite(resultFile_xls,accuracy,range_M);         % accuracies
        xlswrite(resultFile_xls,min_MAE,'C1:C1');          % minimal MAE
        xlswrite(resultFile_xls,min_MAE_id,'E1:E1');          % minimal MAE
        
        % 2. put out the results to command window 
        %resultFile_txt = sprintf('%s_%d.txt',resultFile,ii);
        %fid = fopen(resultFile_txt,'w');        
        for id = [1]
            fprintf(id,'======= %d =============\n',ii);
            fwritef(id,'MAE',MAE,'%.4f','acc1',acc1*100,'%.2f %%', 'acc2',acc2*100,'%.2f %%');
        end    
        %fclose(fid);
    end

end