%function test_matrixFactorizationCF_sparse()

clear

% database = 'ua';
% trainFile = sprintf('../data/%s_train_quiz.mat',database);
% testFile = sprintf('../data/%s_test.mat',database);
% load(trainFile,'Train','Quiz');
% load(testFile,'Test');

database = 'eachmovie';
dataFile = sprintf('../data/%s_sub.mat',database);
load(dataFile,'Train','Test','Quiz');

% 0. Set parameters for the algorithm
opt=struct();
opt.lambda_6 = 0.005; 
opt.lambda_7 = 0.005;
opt.lambda_8 = 0.020;
  % step size 
opt.gamma_1 = 0.007;
opt.gamma_2 = 0.007;%%%
opt.gamma_3 = 0.01;
opt.sigma = 0.95; % decreasing scalar for step size
opt.alpha = 0.70; % the role of nearest neighbors
opt.nNbr = 400;  %%%   % neighborhood size
opt.nf = 10; % factor space dimension
opt.ite_num = 5; % iteration number
opt.threshold = opt.nNbr;  % threshold
  % similarity file containing similarities between items
opt.similarityFile = '../iteration/similarity_item_train_eachmovie.mat';
opt.verbose = 1;
opt.classicalSVD = 0;

  % 4 sets of parameters
opt_cell = cell(1,4);
opt_cell(:) = {opt};

% opt_cell{1}: classical SVD
opt_cell{1}.classicalSVD = 1;
opt_cell{1}.alpha = 0;
opt_cell{1}.lambda_6 = .005;
opt_cell{1}.lambda_7 = .045;   %.03;
opt_cell{1}.gamma_1 = .007;
opt_cell{1}.gamma_2 = .06;       %.06;  %0.003;


% opt_cell{2}: BellKor01
  % the default parameters
  
% opt_cell{3}: BellKor07
opt_cell{3}.gamma_3 = 0.07;

% opt_cell{4}: BellKor007
opt_cell{4}.lambda_8 = 0.05;
opt_cell{4}.gamma_3 = 0.007;
opt_cell{4}.nf = 7; 
opt_cell{4}.ite_num = 3; 

BETA = 0;

%trainFileName = '/media/000F32790009E692/XiJun/homework/Recom Matrix Decomposition_Matlab/iteration/MatrixFactorization/MatrixFactorizationCF_eachmovie_BellKor_gamma3_4E_6.mat';
%load(trainFileName,'opt');

for i_opt = 1:1 %length(opt_cell)
%     opt = opt_cell{i_opt};
    if opt.classicalSVD
        model_str = 'SVD';
        file_str = sprintf('MF_%s_%s_gamma2_%.3f_lambda7_%.3f_%s.mat',...
            database,model_str,opt.gamma_2,opt.lambda_7,datestr(date)); 
    else
        model_str = 'Bellkor';
        file_str = sprintf('MF_%s_%s_gamma3_%.3f_%s.mat',...
            database,model_str,opt.gamma_3,opt.lambda_7,datestr(date)); 
    end
    trainFileName = sprintf('..%siteration%s%s.mat',filesep,filesep,file_str);
    %  1. train the parameters of the model
    tic;
        matrixFactorizationCF_sparse(Train,trainFileName,opt); 
    train_time = toc; 
     time_str = datestr(now);
    save(trainFileName,'opt','time_str','-append');
    
    % 2. predict the entries of the test set
    set_cell={'Quiz','Test'};
    
    for ii = 1:length(set_cell)
        T = eval(set_cell{ii});
        str = sprintf('..%sresult%sresult_MF_%s_%s_%s_gamma3_%.3f_gamma2_%.3f',...
            filesep,filesep,database,set_cell{ii},model_str,opt.gamma_3,opt.gamma_2);
        resultFile = [str '.txt'];
        resultFile_mat = [str '.mat'];
        [user_v item_v] = find(T~=BETA);
        r_v = predictTestSet(trainFileName,user_v,item_v);
        % 3. calculate the predict precision
        [MAE acc1 acc2 BadEntryRate  ErrorRate] = indicator_precision(user_v,item_v,r_v,T,BETA);
        % 4. put out the result to file and to command window
        time_str = datestr(now);
        save(resultFile_mat,'r_v','MAE','acc1','acc2','BadEntryRate','ErrorRate','opt','time_str');

        fid = fopen(resultFile,'w');
        for id = [1 fid]
            fwritef(id,'',datestr(now),'');
            fwritef(id,'data set',database,'','',set_cell{ii},'');
            fwritef(id,'lambda_6',opt.lambda_6,'%.4f','lambda_7',opt.lambda_7,'%.4f','lambda_8',opt.lambda_8,'%.4f');
            fwritef(id,'gamma_1',opt.gamma_1,'%.4f','gamma_2',opt.gamma_2,'%.4f','gamma_3',opt.gamma_3,'%.4f');
            fwritef(id,'sigma',opt.sigma,'%.2f','alpha',opt.alpha,'%.3f','nNbr',opt.nNbr,'%d',...
                'nf',opt.nf,'%d','ite_num',opt.ite_num,'%d','threshold',opt.threshold,'%d');
            fwritef(id,'MAE',MAE,'%.4f','acc1',acc1*100,'%.2f %%', 'acc2',acc2*100,'%.2f %%');
            fwritef(id,'BadEntryRate',BadEntryRate*100,'%.2f %%', 'ErrorRate',ErrorRate*100,'%.2f %%');
           fprintf(id,'time elapsed for training the model: \t %.1f s\n',train_time);
        end
        fclose(fid);
    end
end