function [u] = itemAverage(R,BETA)
% compute the average rating for each item, if the item is not rated any
% user,its average rating will be set 0.
% Inputs
%  R, BETA:  raing matrix, with BETA (a real number) the missing ratings
% Outputs
%  u: a column vector with the length as the column number of matrix R,
%   u(i) indicate the average rating of item i

I = (R~=BETA);
u = sum(R.*I,1)./max(sum(I,1),1); 
    % max(...,1): deal with the case that some elements of sum(I,1) is 0;