function main_nearest_neighbor()
% test the Nearest Neighbor method

% database = 'ua';
% trainFile = sprintf('../data/%s_train_quiz.mat',database);
% testFile = sprintf('../data/%s_test.mat',database);
% baseFile = sprintf('../data/%s_base.mat',database);
% load(trainFile,'Train','Quiz');
% load(testFile,'Test');
% load(baseFile,'Base');

database = 'eachmovie';
dataFile = sprintf('../data/%s_sub.mat',database);
load(dataFile,'Train','Quiz','Test');

BETA = 0;
nbrSize = 50; % neighbors for each user when calculate the weighted average
%nbrSize_similarity = 943; % neighbors for each user when calculate the similarity matrix S
%threshold = 50;
flag_all_entries = 1;


predictFile = sprintf('../iteration/NearestNeighbor/predict_nNbr_%s.mat',database);
resultFile_0 = sprintf('../result/NearestNeighbor/result_nNbr_%s',database);

  % predict the testing elements  
 users = []; items = [];  
 Predict = nearest_neighbor_prediction(Train,BETA,users,items,nbrSize,flag_all_entries);
 save(predictFile,'users','items','Train','Predict','Test','BETA');
%load(predictFile,'Predict');

  % calculate the precision
TestSet = {'Test','Quiz'};
[nUser nItem] = size(Train);
for ii = 1:length(TestSet)
    Set = TestSet{ii};
    resultFile = sprintf('%s_%s.mat',resultFile_0,Set);
    [MAE acc1 acc2 BadEntryRate  ErrorRate] = indicator_precision(users,items,Predict,eval(Set),BETA);
    % put out the predictions to files
    [users items] = find(eval(Set));    
    II = sparse(users,items,ones(length(users),1),nUser,nItem)~=0;
    r_v = Predict(II);
    save(resultFile,'MAE','acc1','acc2','BadEntryRate','ErrorRate'); 
    save(resultFile,'users','items','r_v','-append');
      % print results
    printResult();
end


    function printResult()
      for id=1          
        fprintf(id,'number of entries for %s:\t%d\n',Set,nnz(eval(Set)));
        fprintf(id,'MAE:\t%.3f\tacc1:\t%.2f %%\tacc2:\t%.2f %%\n',MAE,acc1*100,acc2*100);
        fprintf(id,'bad entry rate: %.2f%% \tErrorRate:%.2f%%\n',BadEntryRate*100,ErrorRate*100);
        fprintf(id,'\n\n');
      end
    end

end

