function [u] = userAverage(R,BETA)
% compute the average rating for each user, if the user does not rate any item
%   his average rating will be 0.
% Inputs
%  R, BETA:  raing matrix, with BETA (a real number) the missing ratings
% Outputs
%  u: a column vector with the length as the row number of matrix R,
%   u(i) indicate the average rating of user i

I = (R~=BETA);
u = sum(R.*I,2)./max(sum(I,2),1); 
    % max(...,1): deal with the case that some elements of sum(I,2) is 0;
u = full(u);    