function y = clip_0(x,alpha)
% Inputs: 
%  x: a column vector;
%  alpha: a scalar, 0<=alpha<=0.5;
% Outputs:
%  y: the column vector after clipped, the same length as x;
%  y(i) = round(x(i)), if |x(i)-round(x(i))|<=alpha;
%            x(i),     otherwise;
y = x;
if alpha<=0
    return;
end
z = round(x);
I = abs(x-z)<=alpha;
y(I) = z(I);
end