% draw_MAE_3sheep.m
% draw MAEs on white, gray and black sheep of nNbr-user method

MAE = [0.6015 	0.7298 	0.8752 0.7349; ... % on MovieLens 
       0.6813 	0.9260 	1.1641 0.9240]; % on EachMovie
h = bar(MAE,'grouped');

figure_FontSize=14;
color_sheep = {'none',[0.7 0.7 0.7],[0.4 0.4 0.4],[.9, .9, .9]};

set(gca,'XTickLabel',{'on MovieLens','on EachMovie'},'FontSize',figure_FontSize);

% set color for faces of bars
for ii=1:length(color_sheep)
    set(h(ii),'FaceColor',color_sheep{ii});
end
% legends
h_legend = legend('white sheep','gray sheep', 'black sheep','total');
set(h_legend,'FontSize',figure_FontSize-2);

% save the figure
pathStr = [rootpath filesep 'figure' filesep 'relatedness' filesep];
saveas(gcf,[pathStr 'MAE_3sheep'  '.fig']);
saveas(gcf,[pathStr 'MAE_3sheep'  '.eps'],'psc2');