% draw_MAE_RMSE_3sheep.m 
% draw MAE and RMSE of 3 sheep on quiz set

clear

dataset = 'ua';
arg.padMAE = 0;
pad = num2str(arg.padMAE);
pad=regexprep(pad,'\.','_'); 
chaosFileKey = [dataset '_chaos_pad_' pad '_mae_rmse']; % mae_rmse: consider both MAE and RMSE

% load result data
% dataset = 'eachmovie';   % 'ua';
% pad = '0';
% chaosFileKey = sprintf('%s_chaos_pad_%s',dataset,pad);

chaosFile = getFileName(chaosFileKey);
load(chaosFile, 'MAE','RMSE');

id_set = 1; % 1: quiz set, 2: test set
id_model = 5; % 5: nNbr-user
v_sheep = 1:3; % 1: white sheep;  2: gray sheep;   3: black sheep

figure_FontSize=14;
color_sheep = {'none',[0.7 0.7 0.7],[0.4 0.4 0.4]};

A = zeros(2,length(v_sheep));

A(1,:) = MAE(id_model,v_sheep,id_set);
A(2,:) = RMSE(id_model,v_sheep,id_set);
disp(A);

h = bar(A,'grouped');
set(gca,'XTickLabel',{'MAE','RMSE'},'FontSize',figure_FontSize);
% set color for faces of bars
for ii=1:length(color_sheep)
    set(h(ii),'FaceColor',color_sheep{ii});
end
% legends
legend('white sheep','gray sheep', 'black sheep');

% save the figure
pathStr = [rootpath filesep 'figure' filesep 'relatedness' filesep];
saveas(gcf,[pathStr 'MAE_RMSE_3sheep_' dataset '.fig']);
saveas(gcf,[pathStr 'MAE_RMSE_3sheep_' dataset '.eps'],'psc2');