% draw_clip_MAE_RMSE.m
% draw the relationship between MAE and RMSE clipping under various levels

%clipFile = getFileName('ua_clip_whole_chaos');
%pad = '0_1';
%pad = '0_05';
pad = '0_02';
clipFileKey = ['ua_clip_whole_chaos' pad];
clipFile = getFileName(clipFileKey);

load(clipFile,'MAE','RMSE');

nlevel = size(MAE,1);

clip_level = [0 0.1 0.2 0.3 0.4 0.5];
sampleSet = {'Test'}; % {'Quiz'}

for ii=1:length(sampleSet)
    if strcmpi(sampleSet{ii},'quiz')
        i_col = 1;
    else % strcmpi(sampleSet{ii},'test')
        i_col = 2;
    end
    
    MAE_v = MAE(1:nlevel-1,i_col); % column 1 store the MAE on Quiz set, and column 2 Test set
    RMSE_v = RMSE(1:nlevel-1,i_col);
    % plot the relationship of MAE and RMSE
        % dipict the relation of MAE-RMSE 
    plot(RMSE_v,MAE_v,'-om','LineWidth',2,'MarkerSize',5,'Color',[.5 .3 .1],'MarkerFaceColor',[.5 .3 .1]);
        % set the text to indicate the clipping levels
    for i_level=1:length(clip_level)
        text(RMSE_v(i_level),MAE_v(i_level),sprintf(' \\leftarrow level:%3.1f',clip_level(i_level)),'HorizontalAlignment','left');
    end
    hold on
    % plot the point of (RMSE MAE) for Chaos-clip
    plot(RMSE(nlevel,i_col),MAE(nlevel,i_col),'sm','MarkerSize',6,'MarkerFaceColor','g');
    text(RMSE(nlevel,i_col),MAE(nlevel,i_col),' \leftarrow rel-round','HorizontalAlignment','left'); %coherence-rounding
    % set the title and axis
    %title(sprintf('RMSE and MAE of Chaos under various rounding levels (%s)',sampleSet{ii}));
    xlabel('RMSE');
    ylabel('MAE');
    grid on
    hold off
    % save the figure
    pathStr = [rootpath() filesep 'figure' filesep 'bridge' filesep];
    saveas(gcf,sprintf('%sua_clip_whole_chaos_%s%s.fig',pathStr,sampleSet{ii},pad));
    saveas(gcf,sprintf('%sua_clip_whole_chaos_%s%s.eps',pathStr,sampleSet{ii},pad),'psc2');
end

