% draw_dist_MAE_4_sheep.m

% draw the distribution of MAE of the entries on White, Gray, Black sheep

% load result 
dataset =  'eachmovie';   %'ua';%
pad = '0';

chaosFileKey = sprintf('%s_chaos_pad_%s',dataset,pad);
chaosFile = getFileName(chaosFileKey);
%chaosFile = getFileName('ua_chaos');
load(chaosFile,'rr_quiz','rr_test','white_q','gray_q','black_q','blue_q','white_t','gray_t','black_t','blue_t');

nNbrFile_quiz = getFileName(sprintf('%s_quiz_nnbr_result',dataset));
nNbrFile_test = getFileName(sprintf('%s_test_nnbr_result',dataset));

keyResultFile = sprintf('%s_dist_MAE_3_sheep',dataset);
resultFileName = sprintf('%s_dist_MAE_3_sheep.mat',dataset);
if ~existFileRecord(keyResultFile)
    addFileRecord({['result' filesep 'bridge'],keyResultFile,resultFileName});
end
resultFile = getFileName(keyResultFile);

id_v_name_quiz = {'white_q','gray_q','black_q'};
id_v_name_test = {'white_t','gray_t','black_t'};
sheep_v_name = {'white sheep','gray sheep','black sheep'};
if strcmpi(dataset,'ua')
    bags = [0.5 1.0 1.5 2.0 4.0]';
else
    bags = [0.5 1.0 1.5 2.0 5.0]';
end
color_bags = {[.9 .9 .9],[.7 .7 .7],[.5 .5 .5],[.3 .3 .3],[.2 .2 .2]};  % face color of bar for each bag

figure_FontSize=14;
SetName = {'Quiz'};
SetID = {'quiz'};
%SetName = {'Test'}; SetID = {'test'};
percentage_MAE_Quiz = [];
percentage_MAE_Test = [];
for i_set = 1:length(SetName)
    fileName = eval(sprintf('nNbrFile_%s',SetID{i_set}));
    rr = eval(sprintf('rr_%s',SetID{i_set}));
    id_v_name = eval(sprintf('id_v_name_%s',SetID{i_set}));
    load(fileName,'r_v');
    MAE_v = abs(r_v-rr);
    % draw the distribution of MAE on the 3 group of sheep    
    len_id_v_name = length(id_v_name);
    len_bags = length(bags);

    percentage_MAE = zeros(len_id_v_name,len_bags); % percentage of MAE located in each bags
    for jj=1:len_id_v_name
        id_v = eval(id_v_name{jj});
        [num_balls indices_bags]= falltoBags(MAE_v(id_v),bags);
        percentage_MAE(jj,:)=num_balls'/sum(num_balls);
    end
    legend_cell = cell(len_bags,1);
    for ii=1:len_bags
        if ii == 1
            bags_l = 0;
        else
            bags_l = bags(ii-1);
        end
        bags_u = bags(ii);
        legend_cell{ii}=sprintf('MAE:%.1f-%.1f',bags_l,bags_u);
    end
            % plot the bars
    h=bar(percentage_MAE*100); % *100: rate --> pertentage
    % set color for faces of bars
    for ii=1:length(color_bags)
        set(h(ii),'FaceColor',color_bags{ii});
    end
    ylabel('percentage','fontsize',figure_FontSize);    
    set(gca,'XTickLabel',sheep_v_name,'fontsize',figure_FontSize);
    h_legend = legend(legend_cell);
    set(h_legend,'FontSize',figure_FontSize-4);
    
    % set the font size of labels and TickLabel
  %  set(get(gca,'XLabel'),'FontSize',figure_FontSize,'Vertical','top');
   % set(get(gca,'YLabel'),'FontSize',figure_FontSize,'Vertical','middle');
    
    
  
%    title(sprintf('distribution of MAE on various sheeps (%s)',SetName{i_set}));
        % save the figure
	pathStr = [rootpath() filesep 'figure' filesep 'bridge' filesep];
    saveas(gcf,sprintf('%sdist_MAE_3_sheep_%s_%s.eps',pathStr,dataset,SetName{i_set}),'psc2');
    saveas(gcf,sprintf('%sdist_MAE_3_sheep_%s_%s.fig',pathStr,dataset,SetName{i_set}));
    
        % save the results
    var_str = sprintf('percentage_MAE_%s',SetName{i_set});
    eval(sprintf('%s=percentage_MAE',var_str));
    if ~exist(resultFile,'file')
        save(resultFile,var_str);
    else
        save(resultFile,var_str,'-append');
    end
       
end
