
% draw_dist_MAE_clippings.m

% draw the distribution of MAE of the entries on various clipping level and
%  on Chaos_1, Chaos_Clip

clear

%clipFile = '../result/bridge/clip_whole.mat';
% chaosFile = '../iteration/chaos.mat';
% resultFile = '../result/bridge/dist_MAE_clipping.mat'; % file to save the results

clipFile = '../result/bridge/clip_whole_Chaos_2.mat';
chaosFile = '../iteration/chaos_2.mat';
resultFile = '../result/bridge/dist_MAE_clipping_2.mat'; % file to save the results

% load the predictions and real ratings
load(chaosFile,'rr_quiz'); % real ratings in Quiz set
load(clipFile,'X_clip_quiz');

% stachastic the distribution of MAE
len_level = size(X_clip_quiz,2); % number of clipping levels
bags_MAE = [0.5 1.0 1.5 2.0 4.0]'; 
len_bags = length(bags_MAE);
percentage_MAE = zeros(len_level,len_bags); % percentage of MAE located in each bags
for i_level=1:len_level
    [num_balls]= falltoBags(abs(X_clip_quiz(:,i_level)-rr_quiz),bags_MAE);
    percentage_MAE(i_level,:)=num_balls'/sum(num_balls);
end

% set the legend
legend_cell = cell(len_bags,1);
for ii=1:len_bags
    if ii == 1
        bags_l = 0;
    else
        bags_l = bags_MAE(ii-1);
    end
    bags_u = bags_MAE(ii);
    legend_cell{ii}=sprintf('MAE:%.1f-%.1f',bags_l,bags_u);
end

% set the XTickLabel
XTickLabel_cell = cell(len_level,1);
level_v = 0:0.1:0.5; % clipping levels
for ii=1:length(level_v)
     XTickLabel_cell{ii}=sprintf('level: %.1f',level_v(ii));
end
XTickLabel_cell{len_level-1} = 'Chaos_1';
XTickLabel_cell{len_level} = 'coherence-rounding';

% plot the bars
bar(percentage_MAE);
ylabel('percentage');
set(gca,'XTickLabel',XTickLabel_cell);
legend(legend_cell);
title(sprintf('distribution of MAE on various rounding levels (Quiz)'));
    
% save the results
save(resultFile,'percentage_MAE');
      
