% draw the relationship between relatedness and MAE

% this function draw the figure  based on the data:
%   * calculated relatedness 
%   * predicted ratings from liseted models
% the key of the file to store the predicted ratings are as follows
%   keyPredictResultFile = sprintf('%s_%s_%s_result',dataSet,sampleSet,modelName);
% the key of teh file to store the relatedness (entropy) values are as follows
%   relKey = sprintf('%s_%s_%s_homotopy',dataSet,sampleSet,style_str);
%   where style_str = 'adaptive' or 'static';

clear
%dataSet = 'ua';
dataSet = 'eachmovie';
%sampleSet =  'test';
sampleSet =  'quiz';
flag_color_figure = 1; 
    % 1 or 0, indicating whether to plot a color figure(s), (otherwise a
    % grey figure will be plotted);

%model_cell = {'nNbr_item','nNbr','MF','entropy'};
model_cell = {'nNbr_item','nNbr','MF','entropy','bellkor'};
modelName_cell = {'nNbr-item','nNbr-user','SVD','Rel','BellKor01'};
if flag_color_figure
    lineColor_cell = {[0.8 0.2 0.2] [0.2 0.8 0.2] [0.2 0.2 0.8] [0.35 0.35 0.35] [0.85 0.60 0.65 ]};
    lineStyle_cell = {'-', '-','-.','-','--'};
else % plot grey figure
    grey_v1 = [.3 .3 .3];
    grey_v2 = [.45 .45 .45];
    grey_v3 = [.7 .7  .7];
    lineColor_cell = {grey_v2, grey_v3, grey_v2, grey_v1, grey_v2};
    lineStyle_cell = {'-', '-','-.',':','--'};
end

%MAE_whole = [.7479, .7349,  .7227 .752]; 
%MAE_white = [ .70, .69, .6800 .750]; % .750: set casually

flag_dynamic_submatrix_size = 1; % whether use dynamic submatrix size 

index_name = 'relatedness';
%index_name = 'Entropy'; % the name of the proposed index is revised to Entropy before submitting;
                        % when you read an index name ''relatedness'', we
                        % view it the same thing as we name 'Entropy';

if flag_dynamic_submatrix_size
    static_str = '';
    style_str = 'adaptive';
else
    static_str = 'static_';
    style_str = 'static';
end

for ii=1:length(model_cell)
    modelName = model_cell{ii};    
    % get name of result file 
    varPredictResultName = sprintf('file_%s_%s_%s',modelName,sampleSet,dataSet);
    keyPredictResultFile = sprintf('%s_%s_%s_result',dataSet,sampleSet,modelName);
    eval(sprintf('%s=getFileName(''%s'');',varPredictResultName,keyPredictResultFile));
    if isempty(varPredictResultName)
        warn('filekey: "%s" do not exist.', varPredictResultFile);
    end
    % register files which stores the corresponding distribution of
    % relatedness & MAE and get the file name, 
    %  these relatedness files below are generated by this function;   
    varDistName = sprintf('resultFile_%s_%s_%s',modelName,sampleSet,dataSet);  
    keyDistFile = sprintf('%s_%s_%s_reldist',dataSet,sampleSet,modelName);       
    distName = sprintf('%s_relDist_%s_%s%s.mat',dataSet,modelName,static_str,sampleSet);
    % update the file records
    delFileRecord(keyDistFile);
    addFileRecord({['result' filesep 'bridge'],keyDistFile,distName}); 
    % get the file name (include path)
    eval(sprintf('%s=getFileName(''%s'');',varDistName,keyDistFile));
end



% get relaltedness file name
varRelFile = sprintf('relFile_%s_%s',sampleSet,dataSet);
relKey = sprintf('%s_%s_%s_homotopy',dataSet,sampleSet,style_str);
eval(sprintf('%s = getFileName(''%s'');',varRelFile,relKey));

if flag_dynamic_submatrix_size  
    if strcmpi(dataSet,'ua')
        relatedness_range = [2.0,4.5];
    else
        relatedness_range = [1.5,4.5];
    end
  %  relatedness_range = [1.0,4.5];
    coverage_range = relatedness_range;
else
    relatedness_range = [2,5];
    coverage_range = relatedness_range;
end

BETA = 0;
num_rel = 23;
%MAE_base = 0.70;
%MAE_base = 0.9240; % on eachmovie dataset, Quiz set, MAE = 0.9240 by NearestNeighbor 
titleName = sprintf('%s & MAE',index_name);
   
% load relatedness data
load(eval(varRelFile),'rel_v','II','JJ','indices','T');   
[user_v item_v rate_v] = find(T);
h_line_v = zeros(3,1); % handles for relatedness-MAE line

% draw MAE & relatedness lines
%subplot(1,2,1);

clf
subplot(2,1,2);

hold on
for  i_model = 1:length(model_cell)        
    modelName = model_cell{i_model};
    file_predict = eval(sprintf('file_%s_%s_%s',modelName,sampleSet,dataSet));
    file_result = eval(sprintf('resultFile_%s_%s_%s',modelName,sampleSet,dataSet));
    % show the distribution of MAE 
    load(file_predict,'r_v');                
    % calculte the MAE and relatedness distribution
   % if ~exist(file_result,'file')
        [MAE acc1 acc2 BadEntryRate ErrorRate MAE_dist  relatedness_dist] = indicators_index(II(indices),JJ(indices),rel_v,rate_v,r_v,BETA,num_rel,coverage_range);
        save(file_result,'MAE','acc1','acc2','BadEntryRate','ErrorRate','MAE_dist','relatedness_dist','relatedness_range');
    %else
    %   load(file_result,'MAE','acc1','acc2','BadEntryRate','ErrorRate','MAE_dist','relatedness_dist');
    % end
    ErrorNum_vec = round(relatedness_dist(:,4).*relatedness_dist(:,2));
    h_line_v(i_model) = draw_index_dist(relatedness_dist(:,1),'MAE_vec',relatedness_dist(:,3),...
             'index_range',relatedness_range,'indexName',index_name,'modelName',model_cell{i_model},...
             'lineColor',lineColor_cell{i_model},'lineStyle',lineStyle_cell{i_model},'lineWidth',2); %  'MAE_whole',MAE_base,       
end
hold off    
    % set title and legend
% title(sprintf('\\fontsize{12}(b) %s',titleName));
if strcmpi(dataSet,'ua')  
    title(sprintf('\\fontsize{12}(b)'));
else
    title(sprintf('\\fontsize{12}(d)'));
end
legend(h_line_v,modelName_cell);
box on % box on
grid on
% % % save the figure    
% % saveas(gcf,[rootpath() filesep 'figure' filesep 'bridge' filesep 'coherence_MAE_5_method_' dataSet '_' sampleSet '.fig']);
% % saveas(gcf,[rootpath() filesep 'figure' filesep 'bridge' filesep 'coherence_MAE_5_method_' dataSet '_' sampleSet '.eps'],'psc2');

%pause
   % draw the bars of number of entries 
  
colorBar = {[.5 .5 .5]};   
subplot(2,1,1)
draw_index_dist(relatedness_dist(:,1),'num_entry',relatedness_dist(:,2),...          % 'ErrorNum_vec',ErrorNum_vec,...
           'index_range',relatedness_range,'indexName',index_name,'colorBar',colorBar);
if strcmpi(dataSet,'ua')       
    %title('\fontsize{12}(a) Number of entries')
    title('\fontsize{12}(a)');
else
    title('\fontsize{12}(c)');
end

fileName = ['coherence_num_5_method_' dataSet '_' sampleSet];
if flag_color_figure
    fileName = [fileName '_color'];
else
    fileName = [fileName '_grey'];
end

saveas(gcf,[rootpath() filesep 'figure' filesep 'bridge' filesep  fileName '.fig']);
saveas(gcf,[rootpath() filesep 'figure' filesep 'bridge' filesep  fileName '.eps'],'psc2');
