function main_clip_whole()
% calculate the MAE and RMSE under various clipping levels

%chaosFile = '../iteration/chaos_3.mat';
%pad = '0_05';
%pad = '0_1';
%pad = '0_02';
pad = '0';
%keyChaosFile = ['ua_chaos_pad' pad];
keyChaosFile = 'ua_chaos_pad_0_mae_rmse';
chaosFile = getFileName(keyChaosFile);
% chaosFile = getFileName('ua_chaos');
load(chaosFile,'R_quiz','R_test','rr_quiz','rr_test');

% regist and get file name to store the result
resultFileKey = ['ua_clip_whole_chaos' pad];
if ~existFileRecord(resultFileKey)
    addFileRecord({['result' filesep 'bridge'],resultFileKey [resultFileKey '.mat']});
end
resultFile = getFileName(resultFileKey);

n_model = size(R_quiz,2);
id_model = n_model-1;         % R_quiz(:,1): the predictions by SVD;  R_quiz(:,n_model-3): the predictions by Chaos_0;  
                        % R_quiz(:,n_model-1): the predictions by Chaos_svd;                        
%clip_level = [0 0.1 0.2 0.3 0.4 0.5];
clip_level = [0 0.02 0.04 0.06 0.08 0.10 0.12 0.14 0.16 0.18 0.20 0.30 0.40 0.50];
len_clip_level = length(clip_level);

MAE = zeros(len_clip_level+1,2); % column 1: store the MAE in Quiz Set under various clipping level
                               % column 2: store the MAE in Test Set under various clipping level
                               % row 1 -- 6: store the MAE under clipping level 0, 0.1, ..., 0.5;
                               % row 7: store the MAE under clipping of Chaos_clip
                               
acc1 = zeros(len_clip_level+1,2);
acc2 = zeros(len_clip_level+1,2); 
BadEntryRate = zeros(len_clip_level+1,2);  
ErrorRate = zeros(len_clip_level+1,2); 
RMSE = zeros(len_clip_level+1,2);
num_wrong_clip = zeros(len_clip_level+1,2); 
num_clip = zeros(len_clip_level+1,2); 
X_clip_quiz = zeros(size(R_quiz,1),len_clip_level+2); % column 1 -- len_clip_level: store the ratings after clipping
X_clip_test = zeros(size(R_test,1),len_clip_level+2); % column len_clip_level: store the ratings of Chaos_1 and Chaos_Clip

Set = {'quiz','test'};
for i_lev = 1:len_clip_level+1
    % set the clipping level
    if i_lev<=len_clip_level 
        alpha = clip_level(i_lev);
    else
        alpha = [];
    end
    % calculate the accuracy after clipping on level alpha
    for i_set = 1:length(Set);
        r = eval(sprintf('rr_%s',Set{i_set})); % the real ratings
        if i_lev<=len_clip_level 
            x = eval(sprintf('lb_ub_clip(R_%s(:,id_model),1,5)',Set{i_set})); 
                % operate lb_ub_clip beforehand
            x_clip = clip_0(x,alpha);
            eval(sprintf('X_clip_%s(:,i_lev) = x_clip;',Set{i_set})); % store the values of variable x_clip
        else
            x = eval(sprintf('lb_ub_clip(R_%s(:,n_model-1),1,5)',Set{i_set})); % the predictions by Chaos_0;
            x_clip = eval(sprintf('R_%s(:,n_model)',Set{i_set})); % the predictions by Chaos_clip;
            eval(sprintf('X_clip_%s(:,len_clip_level+1) = x;',Set{i_set})); % store the predictions of Chaos_1 
            eval(sprintf('X_clip_%s(:,len_clip_level+2) = x_clip;',Set{i_set})); % store the predictions of Cshaos_clip;
        end
        
        [MAE(i_lev,i_set),acc1(i_lev,i_set),acc2(i_lev,i_set),BadEntryRate(i_lev,i_set),ErrorRate(i_lev,i_set),RMSE(i_lev,i_set)] ...
            =  indicator_precision([],[],x_clip,r,0);
        [num_wrong_clip(i_lev,i_set),num_clip(i_lev,i_set)] = cal_wrong_clip_num(r,x,alpha,x_clip);
    end
end
% len_Quiz = length(rr_quiz);
% len_Test = length(rr_test);
save(resultFile,'MAE','acc1','acc2','BadEntryRate','ErrorRate','RMSE',...
    'num_wrong_clip','num_clip','X_clip_quiz','X_clip_test');
fprintf('Finished to test clip_whole. See %s for detail.\n',resultFile);