relFile_quiz = '../iteration/ua_unrel_Quiz_dynSize.mat';
chaosFile = '../iteration/chaos.mat';
resultFile = '../result/bridge/special_entry_temp.mat';

load(chaosFile,'R_quiz','rr_quiz','user_quiz_v','item_quiz_v');
load(relFile_quiz,'coherence_v');

method_id = [1 4 5];
Err = R_quiz(:,method_id)-repmat(rr_quiz,1,3);
%MAE_min_v = min(Err,[],2)>=2.0 || max(Err,[],2)<=-2.0; % R_quiz(:,[1 4 5]) predictions by SVD, Nearest Neighbor (user-based), Nearest Neighbor (item-based);
coherence_mark_good = 6.75;
coherence_mark_bad = 5.95;
is_special_v = (min(Err,[],2)>=2.0 | max(Err,[],2)<=-2.0);   % the predictions given by the 3 methods are all greater or less than the known rating, at least having a error 2;
% is_special_v = (min(abs(Err),[],2)>=1.0);   
special_id_good = find(is_special_v & coherence_v>coherence_mark_good); % special IDs in good sheep;
special_id_grey = find(is_special_v & coherence_v<=coherence_mark_good & coherence_v>coherence_mark_bad); % special IDs in grey sheep;
special_id_bad = find(is_special_v & coherence_v<=coherence_mark_bad);

user_special_id_good = user_quiz_v(special_id_good);
item_special_id_good = item_quiz_v(special_id_good);
coherence_good = coherence_v(special_id_good);
rr_good = rr_quiz(special_id_good);
R_quiz_good = R_quiz(special_id_good,method_id);

user_special_id_grey = user_quiz_v(special_id_grey);
item_special_id_grey = item_quiz_v(special_id_grey);
coherence_grey = coherence_v(special_id_grey);
rr_grey = rr_quiz(special_id_grey);
R_quiz_grey = R_quiz(special_id_grey,method_id);


user_special_id_bad = user_quiz_v(special_id_bad);
item_special_id_bad = item_quiz_v(special_id_bad);
coherence_bad = coherence_v(special_id_bad);
rr_bad = rr_quiz(special_id_bad);
R_quiz_bad = R_quiz(special_id_bad,method_id);

% print out the mean standard deviation of the predictions on special
%   entries on good and bad points
mean_std_good = mean(std(R_quiz_good,[],2));
mean_std_bad = mean(std(R_quiz_bad,[],2))
fprintf('mean_std_good:\t%.4f\n',mean_std_good);
fprintf('mean_std_bad:\t%.4f\n',mean_std_bad);

fprintf('Finished to identify the special entries. see %s for detail.\n',resultFile);
save(resultFile,'special_id_good','user_special_id_good','item_special_id_good','coherence_good','rr_good','R_quiz_good',...
    'special_id_grey','user_special_id_grey','item_special_id_grey','coherence_grey','rr_grey','R_quiz_grey',...
    'special_id_bad','user_special_id_bad','item_special_id_bad','coherence_bad','rr_bad','R_quiz_bad');