function arg = completeArg(arg,arg_cell,arg_default_val)
% complete values and items of a struture with given values
% Inputs:
%  arg: a structure;
%  arg_cell: a string cell array, indicating the fields to complete;
%  arg_default_val: a cell array with the same size as arg_cell, indicating
%    the values of the corresponding fields;
% Operation:
%  for each field, ITEM, indicated by arg_cell{i}, i =1,2,... 
%   if arg.ITEM is not exist or has empty value,  assign
%       arg.ITEM = arg_default_val{i};

for ii=1:length(arg_cell)
    fieldName = arg_cell{ii};
    if ~isfield(arg,fieldName) || isempty(arg.(fieldName))
        arg.(fieldName) = arg_default_val{ii};
    end
end

end