function act_v = activity(num_rating_user, num_rating_item, user_v,item_v)
% calculate the activity for the entries

% Inputs:
%  num_rating_user, num_rating_item: two column vectors containing the
%    number of ratings for each user and each item;
%  user_v,item_v: two column vectors with the same size, containing
%    user indices and item indices to be calculted;
% Outputs:
% act_v: a column vector with the same length as user_v, containing 
%   activities for each entries;

%  activity(u,i) = min( act_user(u), act_item(i) ) ;
%   where act_user(u) is defined as the number of items user u rated;
%   act_item(i) is defined as the number of users rated item i;

testSize = length(user_v);
act_v = zeros(testSize,1);

for ii = 1:testSize
    act_v(ii) = min( num_rating_user(user_v(ii)),num_rating_item(item_v(ii)) );
end
