function main_Chaos()
% blend the prediction results


% 1. Construct two matrices R_quiz, R_test with each column containing a
% group of prediction results by one model on Quiz set, and Test set, respectively;

           
% quizFile_v = {  getFileName('ua_quiz_svd1_result'),...
%                 getFileName('ua_quiz_svd2_result'),...
%                 getFileName('ua_quiz_svd3_result'),...
%                 getFileName('ua_quiz_svd4_result'),...
%                 getFileName('ua_quiz_nnbr_result'),...
%                 getFileName('ua_quiz_nnbr_item_result'),...
%                 getFileName('ua_quiz_baseline_result'),...
%                 getFileName('ua_quiz_entropy_result'),...
%                 getFileName('ua_quiz_baseline_usermean_result'),...
%                 getFileName('ua_quiz_baseline_itemmean_result'),...
%              };
% testFile_v = {  getFileName('ua_test_svd_7356_result'),...
%                 getFileName('ua_test_svd_7473_result'),...
%                 getFileName('ua_test_svd_7494_result'),...
%                 getFileName('ua_test_svd_7622_result'),...
%                 getFileName('ua_test_nnbr_result'),...
%                 getFileName('ua_test_nnbr_item_result'),...
%                 getFileName('ua_test_baseline_result'),...
%                 getFileName('ua_test_entropy_result'),...
%                 getFileName('ua_test_baseline_usermean_result'),...
%                 getFileName('ua_test_baseline_itemmean_result'),...
%              };

%dataset = 'ua';
dataset = 'eachmovie';

model_cell = {'svd1','svd2','svd3','svd4','nnbr','nnbr_item','baseline','entropy',...
    'baseline_usermean','baseline_itemmean'};
%modelName_cell = {'nNbr-item','nNbr-user','SVD','Rel','BellKor01'};
quizFile_v = cell(size(model_cell));
testFile_v = cell(size(model_cell));
for ii=1:length(model_cell)
    quizFile_v{ii} = getFileName(sprintf('%s_quiz_%s_result',dataset,model_cell{ii}));
    testFile_v{ii} = getFileName(sprintf('%s_test_%s_result',dataset,model_cell{ii}));
end
        
% load the known entries

trainFile = getFileName(sprintf('%s_train_quiz',dataset));
testFile = getFileName(sprintf('%s_test',dataset));

load(trainFile,'Quiz','Train');
load(testFile,'Test');

nModel = length(quizFile_v);
% nTest = 9430;
% nQuiz = 9496;
nTest = nnz(Test);
nQuiz = nnz(Quiz);

R_quiz = zeros(nQuiz,nModel);
R_test = zeros(nTest,nModel);

for ii=1:nModel
    load(quizFile_v{ii},'r_v');
    R_quiz(:,ii) = r_v;
    load(testFile_v{ii},'r_v');
    R_test(:,ii) = r_v;
end

fprintf('1.1 Finished to construct matrices R_quiz, R_test.\n');
fprintf('1.2 Finished to load the known entries.\n');

% 2. Load the relatedness and activities on the entries of Quiz an Test set
relFile_quiz = getFileName(sprintf('%s_quiz_adaptive_homotopy',dataset));
relFile_test = getFileName(sprintf('%s_test_adaptive_homotopy',dataset));

actFile_quiz = getFileName(sprintf('%s_quiz_activity',dataset));
actFile_test = getFileName(sprintf('%s_test_activity',dataset));

% load the activities
load(actFile_quiz,'act_v'); %%%%
act_quiz = act_v;
load(actFile_test,'act_v');
act_test = act_v;

% load the relatedness
load(relFile_quiz,'informs');
rel_quiz = cell2array_informs();
load(relFile_test,'informs');
rel_test = cell2array_informs();
fprintf('2. Finished to load the relatedness and activities.\n');

% 3. chaos


% index_MAE = [ 2.9 .85;
%               3.2 .80;
%               3.3 .75;              
%               3.6 .70;
%               4.0 .68;
%               5.0 .65;];    % this set ensure a good MAE, but RMSE has a slight increase

% index_MAE = [ 2.9  1-0.1;
%               3.2  1-0.12;              
%               3.6  1-0.15;
%               4.0  1-0.17;
%               5.0  1-0.20;];    % this set reach a improved MAE and RMSE
index_MAE = [ 2.9  1-0.06;
              3.2  1-0.06;              
              3.6  1-0.07;
              4.0  1-0.08;
              4.4  1-0.09;
              5.5   1-0.12;];    % this set reach a improved MAE and RMSE          

arg.weight_v = [.30, .40, .30];    
arg.good_bad_line = [];
%arg.blue_activity = 5; %
arg.blue_activity = -1;
%arg.padMAE = 0.1;
%arg.padMAE = 0.05;
%arg.padMAE = 0.02;
arg.padMAE = 0;
arg.l_rating = min(full(Train(Train>0))); % known minimum rating score
arg.r_rating = full(max(max(Train)));%5; % known maximum rating score
arg.indexMode = 'descend';

% file name to store results of chaos-clip 

pad = num2str(arg.padMAE);
pad=regexprep(pad,'\.','_'); 
keyChaosFile = [dataset '_chaos_pad_' pad]; 
if existFileRecord(keyChaosFile)
    delFileRecord(keyChaosFile);	
end
addFileRecord({['iteration' filesep 'bridge'],keyChaosFile,[keyChaosFile '.mat']});

chaosFile = getFileName(keyChaosFile);
Chaos(chaosFile,R_quiz,R_test,Quiz,Test,act_quiz,act_test,rel_quiz,rel_test,index_MAE,arg);

     function rel_v = cell2array_informs()
        %len_inform = length(informs');
        len_inform = length(informs);
        rel_v = zeros(len_inform,1);
        for k=1:len_inform
            rel_v(k) = informs(k).relatedness;
        end
%        rel_v(:) = informs(:).relatedness;
    end

end