function B = adjust_matrix(A,m,n)
% adjust a sparse matrix as one with specified sizes
% Inputs:
%  A: a (sparse) matrix
%  m,n: size of matrix B
% Outputs:
%  B: a (sparse) matrix with size m-by-n
% Operation:
%  if matrix A do not reach m rows or n nolumns, then fill zero elements;
%  if matrix A has some extra rows or column, then clip them;

[a1 a2] = size(A);
if a1==m && a2==n
    B = A;
elseif a1<=m && a2 <=n
    B = [A sparse(a1,n-a2);
             sparse(m-a1,n)];
elseif a1>=m && a2 >=n
    B = A(1:m,1:n);
elseif a1<=m && a2>=n
    B = [A(:,1:n);
         sparse(m-a1,n)];
else % a1>=m && a2<=n
    B = [A(1:m,1:a2)  sparse(m,n-a2)];         
end

end