function bar_line(x_v,bar_v, line_v, labels, legends, title_str)
% draw a figure consists a bar and a line
% Inputs:
%   x_v: a column vectoer containing values on x axis;
%   bar_v: a column vector with the same length as x_v, indicating heights
%       of bars;
%   line_v: a column vector with the same length as line_v, indicating values 
%       of points on lines
%   labels: a cell array with length 3, labels{1},{2} consist the xlabel
%       and left ylabel and right ylabel;
%   legends: a cell array with length 2, labels{1}, {2} consist the legend
%       for the bars (corresponding left y-axis), and the values on the 
%       lines (right y-axis); 
%   title_str: title name for the picture

hold on
    %plot the bars
  bar(x_v, bar_v,'Stack');
%   set(gca,'XLim',x_range,'Layer','top');
  set(gca,'Layer','top');
  legend(legends{1});
  xlabel(labels{1});
  ylabel(labels{2});
    % plot the line
  h1 = gca;
  h2 = axes('Position',get(h1,'Position'));
  plot(x_v,line_v,'c','linewidth',2);
  set(h2,'YAxisLocation','right','Color','none','XTickLabel',[]);
  set(h2,'XLim',get(h1,'XLim'),'Layer','top');
  set(h2,'box','off');
  ylabel(labels{3});
  legend(legends{2});
  title(title_str,'Fontsize',12);
hold off

end