function varargout = getArgument(name_val_cell,argName_cell)
% get the the variables from name-value pair cell array
% Inputs:
%   name_val_cell: a cell array, consists paris of name-value
%    for instance {'index_v', [1.1 1.2 1.3],'indexName','coherence'}
%   argName_cell: a cell array consisting names of the arguments
% Outputs:
%   the variables with the name containing in argName_cell, return [] if
%   the variable name not contained in ARGNAME_CELL

len_name_val = length(name_val_cell);
name_cell_setted = name_val_cell(1:2:len_name_val);
for ii = 1:length(argName_cell)
    name_Var = argName_cell{ii}; 
    i_pair = find_cellstr(name_cell_setted,name_Var);
    if i_pair && 2*i_pair<=len_name_val
        varargout{ii} = name_val_cell{2*i_pair};
    else
        varargout{ii} = [];
    end
end
end

function id = find_cellstr(strcell,str)
% find the first location where str occurs in the cell array strcell (case
% insensitive), return 0 if no occurrance
    is_identical_v = cellfun(@(x_str)strcmpi(x_str,str),strcell);
    id = find(is_identical_v);
    if isempty(id)
        id = 0;
    end
end

