function fileName = getFileName(varargin)
% get file name (includting directory)

% Inputs:
%  if nargin == 1
%       varargin{1}: the key string for the file 
%  else
%    varargin{1}: data set 'ua' or 'ub';
%    varargin{2}: data set 'test', 'quiz', 'train', 'train_quiz' or 'base';
%    varargin{i}: flag string i, i= 3, ...
% Outputs:
%  fileName: a string indicating the file path and name, return empty
%  string: '', if the file (file key) is not exist;

% description: this file construct the key of the file according to the
%   input fields and flags, then seach the objective file information.


% get the root path of the files
rootPath_str = rootpath(getconstant('rootPathDepth'));
    % root path of the files : the path before the current path 
fsep = filesep;


% find the file record
if nargin==1
    keyStr = varargin{1};
else    
    sepstr = '_';
    keyStr = [varargin{1} sepstr varargin{2}];
    for ii = 3:nargin
        keyStr = sprintf('%s_%s',keyStr,varargin{ii});
    end    
end
[id r]=findFileRecord(keyStr);

% add the root path string
fileName = '';
if ~isempty(id)
    fileName =  [rootPath_str fsep r{1} fsep r{3}];
end

end % end of the function

