function val = getconstant(varName)
% return the registered value of the given constant variable 

% define some constants for files information
rootPathDepth = 1; % path depth of rootpath.m (compared with the path of the project)
fileInf = [rootpath(rootPathDepth), filesep, 'data', filesep, 'fileInf.mat']; % file name to storing the file records
fileInf_backup = [rootpath(rootPathDepth), filesep, 'data', filesep, 'fileInf_backup.mat']; % file name to storing the file records
orderSensitiveFlag = 2; % number of the sub-flags for the key that are order sensitive; 

% the fileInf file store the string cell matrix with each row a record of a
% file
% F has columns as follows 
        %     *  direction(string): (relative) path of the file, at the end
        %           (and starting) of this string there is no '/' or '\'   
        %     *  key(string): key of the file, this field is unique for
        %           each record; format of the key field:
        %           $field1_$field2_$flagA1_$flagA2_..._$flagAN
        %           where flagA1, ..., flagAn is a permutation of
        %           flag1,...flagN, that is, the order of the input flags
        %           are not sensitive;
        %     *  fileName(string): file name 
        %     *  variables(string cell array): variable names contained in the file 
        %     *  fileType(string: 'data', 'result', etc.): file type
        %     *  fileDescription(string) : file description
        %     *  others(string): other information 

val = eval(varName);
end