function main_addFileRecord()
% add file records

fsep = filesep;
arg = struct('force',1); % if the key of the record always exist, remove the original record forcely;

%%%%%
backUpFileRecord(); % back up file records
%%%%%

% * $rootpath /iteration/
%      iteration/bridge/
addFileRecord({['iteration' filesep 'bridge'], 'ua_chaos' 'chaos.mat'},arg);
%      iteration/NearestNeighbor/
addFileRecord(addCol(['iteration' fsep 'NearestNeighbor'],...
      {'ua_test_nnbr_mae744',   'predict_nNbr_Base_set_MAE744.mat', ; ...
        % containing variables: Predict, Test, Train, users, items, r_v, BETA
        % prediction by Nearest Neighbor, based on Base set, MAE = 0.744 on
        % Test Set;
        'ua_test_nnbr_user',      'predict_nNbr.mat';...
        'eachmovie_train_nnbr_user',      'predict_nNbr_eachmovie.mat';...
           % based on train set
        'eachmovie_train_nnbr_item',      'predict_nNbr_item_eachmovie.mat';   
        }),arg);

%      iteration/relatedness/
addFileRecord(addCol(['iteration' fsep 'relatedness'], ...
    {'ua_test_adaptive_homotopy', 'ua_rel_Test_adaptive_Homotopy.mat';...
     'ua_test_adaptive_pearson',  'ua_rel_Test_adaptive_Pearson.mat';...
     'ua_quiz_adaptive_homotopy', 'ua_rel_Quiz_adaptive_Homotopy.mat';...
     'ua_quiz_static_homotopy',   'ua_rel_Quiz_static_Homotopy.mat';...
     'eachmovie_quiz_adaptive_homotopy', 'eachmovie_rel_Quiz_adaptive_Homotopy.mat';...
     'eachmovie_test_adaptive_homotopy', 'eachmovie_rel_Test_adaptive_Homotopy.mat';...
    }),arg);
      % variables: 'II','JJ','indices','informs','T','BETA','arg' 
      %     where 'informs' is a struct array containing predition
      %     information;
%   iteration/Activity/
addFileRecord(addCol(['iteration' fsep 'Activity'], ...
    {'ua_quiz_activity', 'ua_activity_Quiz.mat'; ...
     'ua_test_activity', 'ua_activity_Test.mat'; ...     
     % on EachMovie
     'eachmovie_quiz_activity', 'eachmovie_activity_Quiz.mat'; ...
     'eachmovie_test_activity', 'eachmovie_activity_Test.mat'; ...
    }),arg);

% 2. $rootPath/data/ 
addFileRecord(addCol(['data' fsep],...
    {'ua_base_inf',   'ua_base_inf.mat';... % stachastic information for Base set of ua;
     'ua_train_inf',  'ua_train_inf.mat';... % stachastic information for Train set of ua;
     'ua_test_inf',   'ua_test_inf.mat'; ... % stachastic information for Test set of ua;
        % these 3 files containing variables:
        % ave_num_rating_item  density              inf                  num_user             
        % ave_num_rating_user  dev_rating           num_item             
        % ave_rating           dev_rating_item      num_rating           
        % ave_rating_item      dev_rating_user      num_rating_item      
        % ave_rating_user      dist_rating          num_rating_user 
    'ua_train_quiz',  'ua_train_quiz.mat';...  % 'Train', 'Quiz' (sparse) rating matrix for ua
    'ua_test',        'ua_test.mat';...        % 'Test' (sparse) rating for ua
    % on eachmovie dataset
    'eachmovie_train_inf',  'eachmovie_train_inf.mat';... % stachastic information for Train set of EachMovie
    'eachmovie_train_quiz',  'eachmovie_sub.mat';...  % 'Train', 'Quiz' (sparse) rating matrix of EachMovie dataset
    'eachmovie_test',        'eachmovie_sub.mat';...        % 'Test' (sparse) rating of EachMovie dataset
    }),arg); 

% 3. $rootPaht/result/

addFileRecord(addCol(['result' fsep 'NearestNeighbor'], ...
    {'ua_quiz_nnbr_result','result_nNbr_Quiz.mat';... 
     'ua_quiz_nnbr_item_result','result_nNbr_item_Quiz.mat'; ...
     'ua_test_nnbr_result','result_nNbr_Test.mat';... 
     'ua_test_nnbr_item_result','result_nNbr_item_Test.mat';...
     % on EachMovie dataset
     'eachmovie_quiz_nnbr_result','result_nNbr_eachmovie_Quiz.mat';... 
     'eachmovie_quiz_nnbr_item_result','result_nNbr_item_eachmovie_Quiz.mat'; ...
     'eachmovie_test_nnbr_result','result_nNbr_eachmovie_Test.mat';... 
     'eachmovie_test_nnbr_item_result','result_nNbr_item_eachmovie_Test.mat';...
    }),arg);

addFileRecord(addCol(['result' fsep 'MatrixFactorization'],...
    {'ua_quiz_svd_result', 'result_matrixFactorization_quiz_1.mat';... 
     'ua_quiz_svd1_result','result_matrixFactorization_quiz_1.mat';... 
     'ua_quiz_bellkor_result','result_matrixFactorization_quiz_2.mat';... 
            % these two files above have the same name but with different keys
     'ua_quiz_svd2_result','result_matrixFactorization_quiz_2.mat';... 
     'ua_quiz_svd3_result','result_matrixFactorization_quiz_3.mat';... 
     'ua_quiz_svd4_result','result_matrixFactorization_quiz_4.mat';... 
%      'ua_test_svd_7356_result','result_matrixFactorizationCF_testMAE-7356.mat';...
%      'ua_test_svd_7473_result','result_matrixFactorizationCF_testMAE-7473.mat';...
%      'ua_test_svd_7494_result','result_matrixFactorizationCF_testMAE-7494.mat';...
%      'ua_test_svd_7622_result','result_matrixFactorizationCF_testMAE-7622.mat';... 
     'ua_test_svd1_result','result_matrixFactorizationCF_testMAE-7356.mat';...
     'ua_test_svd2_result','result_matrixFactorizationCF_testMAE-7473.mat';...
     'ua_test_svd3_result','result_matrixFactorizationCF_testMAE-7494.mat';...
     'ua_test_svd4_result','result_matrixFactorizationCF_testMAE-7622.mat';... 
     'ua_test_bellkor_result','result_matrixFactorizationCF_testMAE-7473.mat';...   
     % on EachMovie dataset
     'eachmovie_quiz_svd1_result','result_MF_eachmovie_Quiz_SVD_gamma3_0.010.mat';...      
     'eachmovie_quiz_MF_result',  'result_MF_eachmovie_Quiz_SVD_gamma3_0.010.mat';...      
     %'eachmovie_quiz_svd2_result',   'result_MF_eachmovie_Quiz_Bellkor_gamma3_0.010.mat';... 
     %'eachmovie_quiz_bellkor_result','result_MF_eachmovie_Quiz_Bellkor_gamma3_0.010.mat';... 
     'eachmovie_quiz_svd2_result','result_MF_eachmovie_Quiz_Bellkor_gamma3_0.000.mat';...
     'eachmovie_quiz_bellkor_result','result_MF_eachmovie_Quiz_Bellkor_gamma3_0.000.mat';...
     'eachmovie_quiz_svd3_result','result_MF_eachmovie_Quiz_Bellkor_gamma3_0.070.mat';... 
     'eachmovie_quiz_svd4_result','result_MF_eachmovie_Quiz_Bellkor_gamma3_0.007.mat';... 
     'eachmovie_test_svd1_result','result_MF_eachmovie_Test_SVD_gamma3_0.010.mat';...   
     'eachmovie_test_MF_result',  'result_MF_eachmovie_Test_SVD_gamma3_0.010.mat';...   
%      'eachmovie_test_svd2_result',   'result_MF_eachmovie_Test_Bellkor_gamma3_0.010.mat';... 
%      'eachmovie_test_bellkor_result','result_MF_eachmovie_Test_Bellkor_gamma3_0.010.mat';... 
     'eachmovie_test_svd2_result',   'result_MF_eachmovie_Test_Bellkor_gamma3_0.000.mat';... 
     'eachmovie_test_bellkor_result','result_MF_eachmovie_Test_Bellkor_gamma3_0.000.mat';... 
     'eachmovie_test_svd3_result','result_MF_eachmovie_Test_Bellkor_gamma3_0.070.mat';... 
     'eachmovie_test_svd4_result','result_MF_eachmovie_Test_Bellkor_gamma3_0.007.mat';...      
	}),arg);
% baseline prediction
addFileRecord(addCol(['result' fsep 'Baseline'],...
    {'ua_quiz_baseline_result','result_baseline_Quiz.mat'; ...
     'ua_quiz_baseline_usermean_result','result_userMean_Quiz.mat';...
     'ua_quiz_baseline_itemmean_result','result_itemMean_Quiz.mat';... 
     'ua_test_baseline_result','result_baseline_Test.mat'; ...
     'ua_test_baseline_usermean_result','result_userMean_Test.mat';...
     'ua_test_baseline_itemmean_result','result_itemMean_Test.mat';...
     % on EachMovie dataset
     'eachmovie_quiz_baseline_result','result_baseline_eachmovie_Quiz.mat'; ...
     'eachmovie_quiz_baseline_usermean_result','result_eachmovie_userMean_Quiz.mat';...
     'eachmovie_quiz_baseline_itemmean_result','result_eachmovie_itemMean_Quiz.mat';... 
     'eachmovie_test_baseline_result','result_baseline_eachmovie_Test.mat'; ...
     'eachmovie_test_baseline_usermean_result','result_eachmovie_userMean_Test.mat';...
     'eachmovie_test_baseline_itemmean_result','result_eachmovie_itemMean_Test.mat';...
    }),arg);

    % predicted ratings from entropy (Homotopy)
addFileRecord(addCol(['result' fsep 'entropy'],... 
    {'ua_quiz_entropy_result', 'ua_quiz_entropy_result.mat';... 
     'ua_test_entropy_result', 'ua_test_entropy_result.mat';...
     % on eachmovie dataset
     'eachmovie_quiz_entropy_result', 'eachmovie_quiz_entropy_result.mat';... 
     'eachmovie_test_entropy_result', 'eachmovie_test_entropy_result.mat';...
    }),arg);

disp('finished to add the records');

end



function A = addCol(dir_str,B)
    % add a column cell the first column of the cell matrix B, each
    % element of the added column cell is dir_str        
    [rowB colB] = size(B);
    A = cell(rowB,colB+1);
    A(:,1) = {dir_str};
    A(:,2:colB+1) = B;
end


% ua_test_rating = 'data/ua_test_rating.mat'; % containg ratings to be tested in Test set in type of column vectors
        %containing variables: 'user_test','item_test','r_test','nRating_Test','nUser_test','nItem_test';
