function flag = replaceFileKey(objectKey,alternateKey)
    % replace the key of the file record
% Inputs: 
%    objectKey, alternateKey: two strings, replace the objectKey (if
%    exsit) as alternateKey;
% Outputs:
%    flag: 1: succeed, 0: the objectKey not found;

flag = 0;
if ~exist(getconstant('fileInf'),'file')
    return
end
load(getconstant('fileInf'),'F'); % load file information cell matrix F

alternateKey = strtrim(lower(alternateKey)); % key is not case sensitive
objectKey = strtrim(lower(objectKey));
id = findFileRecord(objectKey);
if isempty(id)
    return
else
    F{id,2} = alternateKey;
end
save(getconstant('fileInf'),'F');
flag = 1;
end