function mysave(filename,varnames_c,suffix,varargin)
% save the given variables in another name
% Inputs:
%   filename: a string, name of mat file to save the variables;
%   varname_c: a cell consisting of the names of variables;
%   suffix: save the given variables with the new names with the format
%            var_name  + suffix 
%   varargin: options to save the variables, see matlab buildin function save()

len_var = length(varnames_c); 

% save the variables to a struct  
varnames_new_c = cellfun(@(str) ([str suffix]), varnames_c,'UniformOutput',false);

% assign the variables to a struct with the new field names (contain suffix)  
s_t = assign_struct('',varnames_new_c,'');
    % generate an empty struct with the fieldnames as the given new varnames
for ii=1:len_var    
    s_t.(varnames_new_c{ii}) = evalin('caller',varnames_c{ii});
end

% save the variables to the mat file
if nargin<=3 
    save(filename,'-struct','s_t');
else
    save(filename,'-struct','s_t',varargin{:});
end

end