function p = operateBag(ball,ind_ball,fun)
% operate on balls in each bags
% Inputs:
%  ball: balls to be operated;
%  ind_ball: a vector with the same length as BALL, indicating the bag
%   index for each ball;
%  fun: a function handle which can accept a vector as input;
% Outputs:
%  p: a column vector, with each element the result for each bag after 
%     operated by function FUN 

bag_v = unique(ind_ball);
nBag = length(bag_v);
p = zeros(nBag,1);
for ii=1:nBag
    p(ii) = fun(ball(ind_ball==bag_v(ii)));
end