function p = rootpath(varargin)
% get the root path of the files
% Inputs:
%  varargin{1}: a positive number indicating path depth of current file
%  (rootpath.m, NOT the function of caller) compared with the root path
% Outputs:
%   p: root path string, there is no filesep at the end of the string

if nargin==0
    currentDepth = 1; 
else
    currentDepth = varargin{1};
end
currPath = fileparts(mfilename('fullpath'));% get current path
fsep = filesep;
pos_v = strfind(currPath,fsep);
p = currPath(1:pos_v(length(pos_v)-currentDepth+1)-1); 
    % root path of the files : the path before the current path 
end
