function  [A0 I J]= subMatrix(A, num)
% construct a sparse matrix by sampling a certain number of entries of a matrix
% Input:
%  A: a matrix
%  num: number of  nonzero elements to sample from A (num<=nnz(A))
% Output:
%  A0: a sparse matrix with the same size as A, the number of nonzeros elements of A0 is: num
%  I, J: two column vectors consisting of the indices of rows and columns:
%       A0 = A(I,J); 

nnz_A = nnz(A);
if num>=nnz_A
    A0 = sparse(A);
    if nargout>1
        [I, J] = find(A);
    end
    return;
end

[m,n] =size(A);
[i , j, v] = find(A);
ind = subVector(1:nnz_A, num);
A0 = sparse(i(ind), j(ind), v(ind), m,n);
if nargout>1
    I = i(ind);
    J = j(ind);
end

end