% main_split_train_quiz_test.m
clear
%
fprintf('!!! NOTE that this code will replace the existed data file!!!\n');
fprintf('print any key to continue.\n');
pause;
% 

% split the raiting scores to 3 part: training set, quiz set and test set


num_user_sample = 4000; % number of users to sample
sampleRate = 1/10; 
score_per_user_test = 10; % sample 10 scores for each user in test set
score_per_user_total = 15; 
    % require that each of the sampled user at least has SCORE_PER_USER_TOTAL ratings

database = 'eachmovie';
dataFile = sprintf('../data/%s_total.mat',database);
dataFile_sub = sprintf('../data/%s_sub.mat',database);

% 1. sample certain number of users
load(dataFile,'R');
[nUser nItem] = size(R);
ind_user_sub0 = subVector(1:nUser,num_user_sample);
R0 = R(ind_user_sub0,:);

% exclude the users that rate less than a certain number of items
I = R0~=0;
num_rating_user = full(sum(I,2)); 
ind_user_sub = ind_user_sub0(num_rating_user>=score_per_user_total);

% exclude the items that received no ratings
num_rating_item = full(sum(I,1)); 
ind_item_sub = find(num_rating_item>0);



R = R(ind_user_sub,ind_item_sub);
R = round(R*5); % score 1, 2, 3,...,6 (star)
save(dataFile_sub,'ind_user_sub0','ind_user_sub','ind_item_sub','R');

fprintf('sampled %d users, %d items\n', size(R,1),size(R,2));

% 2. split the test set

[Base Test] = quiz(R,score_per_user_test);


% 3. split the remain ratings to the training set and quiz set
[Train Quiz] = quiz(Base,sampleRate);

save(dataFile_sub,'Test','Train','Quiz','-append');


%%%% put out the information of the splited rating matrices
nnz_train  = nnz(Train);
nnz_quiz = nnz(Quiz);
nnz_test = nnz(Test);
nnz_R = nnz(R);
fwritef(1,'nnz_train',nnz_train,'%d','nnz_quiz',nnz_quiz,'%d','nnz_test',nnz_test,'%d');
fwritef(1,'nnz_R',nnz_R,'%d');