% test_parameter_rel.m
% test the effects of the parameters for the relatedness value

clear
% parameters
%%num_sub_quiz = 100; %2400; % number of user-item pairs of the independent set 
rate_sub_quiz = 0.5; %0.2;%0.04; %% sampling rate from quiz set
flag_new_sub_quiz = 1; % 1 or 0: whether to generate a new independent set of testing user-item pairs

% datasets: MovieLens and EachMovie
database = 'ua'; % 'eachmovie'; %
train_quiz_file = getFileName(database,'train','quiz');
fwritef(1,'database',database,'');
   % predict result by Nearest Neighbor
if strcmpi(database,'ua')
    predictFile  = '../iteration/NearestNeighbor/predict_nNbr.mat';
else
    predictFile  = '../iteration/NearestNeighbor/predict_nNbr_eachmovie.mat';
end
load(predictFile,'Predict','BETA');
%%arg.BETA = BETA; 

 
% load the quiz dataset
load(train_quiz_file,'Train','Quiz');

% sample a certain number of ratings as an independent set to evaluate the
%   effects of the calulated relatedness metric
rel_ite_file = sprintf('../iteration/relatedness/data_quiz_sub_parameter_%s.mat',database);

%%nnz_sub_quiz = min(nnz(Quiz),num_sub_quiz);
nnz_sub_quiz = round( nnz(Quiz) * rate_sub_quiz);
%%%
fwritef(1,'#test size',nnz_sub_quiz,'%d');
%%%
if flag_new_sub_quiz || ~exist(rel_ite_file,'file')	    
    [Quiz_sub I J]= subMatrix(Quiz,nnz_sub_quiz);
    fprintf(1,'New subset has been produced for testing.\n');
    if exist(rel_ite_file,'file')
      save(rel_ite_file,'Quiz_sub','I','J','-append');
    else
      save(rel_ite_file,'Quiz_sub','I','J');
    end
else    
    load(rel_ite_file,'Quiz_sub','I','J');   
    fprintf(1,'Load Existed subset for testing.\n');
end
% assign arg
arg = struct('I',I,  'J', J, 'BETA', BETA);

% given a set of testing parameters
 % experiment 1.   
% par_baseline = struct('n1',20,'n2',3*20,'r0', 0.8, 'r1', 0.6,  'r2', 0.4,  ...
%     'kappa_alpha_coef', 1.0, 'kappa_beta_coef',1.0);
 % experiment 2.   
% par_baseline = struct('n1',40,'n2',135,'r0', 1.0, 'r1', 0.8,  'r2', 0.6,  ...
%     'kappa_alpha_coef', 1.0, 'kappa_beta_coef',1.0);
% experiment 3.   
%  par_baseline = struct('n1',80,'n2',170,'r0', 0.8, 'r1', 0.6,  'r2', 0.4,  ...
%      'kappa_alpha_coef', 1.0, 'kappa_beta_coef',1.0);
% experiment 4. para24 
par_baseline = struct('n1',20,'n2',60,'r0', 1.0, 'r1', 0.8,  'r2', 0.6,  ...
     'kappa_alpha_coef', 1.0, 'kappa_beta_coef',1.0); 
par_baseline2 = struct('n1',60,'n2',160,'r0', 0.8, 'r1', 0.6,  'r2', 0.4,  ...
      'kappa_alpha_coef', 1.0, 'kappa_beta_coef',1.0);
% experiment 5. para11   
% par_baseline = struct('n1',20,'n2',60,'r0', 0.8, 'r1', 0.6,  'r2', 0.4,  ...
%      'kappa_alpha_coef', 1.0, 'kappa_beta_coef',1.0);


 
  % baseline parameters
par_style = struct('n1','A*','n2','A*','r0', 'B+', 'r1', 'B+',  'r2', 'B+',...
    'kappa_alpha_coef', 'C+', 'kappa_beta_coef','C+');
    % n1, n2 is in group A, traversing style: *
    % r0, r1, r2 is in group B, traversing style: +
    % kappa_alpha_coef, kappa_beta_coef is in group C, traversing style: +

 % experiment 1.    
 % par.n1 = {20, 10, 30, 40};
% par.n2 = {3*20,  180};
% experiment 2. 
% par.n1 = {20,  40, 60, 80};
% par.n2 = {90, 135,  180};
% experiment 3. 
% par.n1 = { 40, 60, 80,100};
% par.n2 = {140, 170,  200};
% experiment 4.  para24,      
 par.n1 = {10, 20,  40}; 
 par.n2 = {60,  120};
 par2.n1 = { 40, 60, 80,100};
 par2.n2 = {150,  200};
% experiment 5. para11 
% par.n1 = {10, 20,  40};
% par.n2 = {60,  120};


% n1, n2 is a group,
    %  traverse style: '*'  :  traverse each possible combinations
    %    (par.n1{1}, par.n2{1}),  (par.n1{1}, par.n2{2}), ... (par.n1{1}, par.n2{N2})
    %     ...
    %    (par.n1{N1}, par.n2{1}),  (par.n1{N1}, par.n2{2}), ... (par.n1{N1}, par.n2{N2})
    %
    %    with N1 = length(par.n1), n2 = length(par.n2);
    
% experiment 1. 
% par.r0 = {1.0,  0.5};
% par.r1 = {0.8,  0.4};
% par.r2 = {0.6,  0.2}; 
% % experiment 2.
% % par.r0 = {0.8};
% % par.r1 = {0.6};
% % par.r2 = {0.4};
% experiment 3.
% par.r0 = {1.0};
% par.r1 = {0.8};
% par.r2 = {0.6};
% % experiment 4.
par.r0 = {0.8, 0.7,  0.6};
par.r1 = {0.6, 0.6,  0.5};
par.r2 = {0.4, 0.35, 0.3};
par2.r0 = par.r0;
par2.r1 = par.r1;
par2.r2 = par.r2;

% experiment 5. 
% par.r0 = {0.8, 0.7,  0.6};
% par.r1 = {0.6, 0.6,  0.5};
% par.r2 = {0.4, 0.35, 0.3};

	% r0, r1, r2 is a group, 
    % traverse style '+' : traverse corresponding parameters:
    %    (par.r0{1},par.r1{1}, par.r2{1}),  (par.r0{2},par.r1{2}, par.r2{2}), ... (par.r0{N},par.r1{N}, par.r2{N})
    %   with N = length(par.r0);
    %
    % MAKE SURE THAT r2,n2 satisfies that n2*r2>r1*n1.

 % experiment 1.    
% par.kappa_alpha_coef =  {0.2, 50.0};
% par.kappa_beta_coef =   {0.2, 50.0};
% % experiment 2. and 3. 
% par.kappa_alpha_coef =  {10.0};
% par.kappa_beta_coef =   {10.0};
 % experiment 4.    
 par.kappa_alpha_coef =  {0.2, 10.0};
 par.kappa_beta_coef =   {0.2, 10.0}; 
 par2.kappa_alpha_coef =  {0.2, 10.0};
 par2.kappa_beta_coef =   {0.2, 10.0};
% par.kappa_alpha_coef =  {0.2, 5.0};
%  par.kappa_beta_coef =   {0.2, 5.0}; 
%  par2.kappa_alpha_coef =  {0.2, 5.0};
%  par2.kappa_beta_coef =   {0.2, 5.0};
 
 % experiment 5.    
%  par.kappa_alpha_coef =  {0.2, 10.0};
%  par.kappa_beta_coef =   {0.2, 10.0};
 
par0.predictFile = predictFile;
par0.style = 'adaptive';
par0.machine = 'Homotopy';

% calculate the relatedness values with each set of parameters
  % experiment 4
par_tv = struct2struct_array_new(par,par_style,par_baseline);
par2_tv = struct2struct_array_new(par2,par_style,par_baseline2); %%
len_par_tv  = length(par_tv);
len_par2_tv = length(par2_tv);
par_tv(len_par_tv+1:len_par_tv+len_par2_tv) = par2_tv; % unify the two struct array
  % experiment 5. 
%par_tv = struct2struct_array_new(par,par_style,par_baseline);

  % assign the fields of par0 to par_tv  
par_tv = assign_struct(par_tv,'',par0);
   
ite_file = sprintf('../iteration/relatedness/ite_papameter_rel_%s.mat',database);
%%resultfile = sprintf('../result/relatedness/result_papameter_rel_%s.mat',database);    
%%BETA = 0; 
%%bag_num_rel = 2;
len_par_tv = length(par_tv);
diff_v = zeros(len_par_tv,1);
t_v = zeros(len_par_tv,1);

% if matlabpool('size') == 0
%     matlabpool('open');
% end
% parfor ii=1:len_par_tv
for ii=1:len_par_tv % 1 %
    %%%
    fprintf('parameter %d. \n',ii);
    %%fwritef(1,sprintf('par_%d',ii),par_tv(ii),'');
    %%%
    tic
    par_i = par_tv(ii);
    [rel_v grade_v inform_tv]= rel_testset(train_quiz_file,I,J,par_i);
    if ~exist(ite_file,'file')
        mysave(ite_file,{'ii','par_i','rel_v','grade_v','inform_tv'},...
            sprintf('_%d',ii) );
    else
        mysave(ite_file,{'ii','par_i','rel_v','grade_v','inform_tv'},...
            sprintf('_%d',ii), '-append');
    end    
    t = toc;
    % evaluate the relatedness metric
    [diff mae_T1 mae_T2]= diff_mae(rel_v,Quiz_sub, Predict,arg); %%
    mysave(ite_file, {'diff'},sprintf('_%d',ii),'-append');
    diff_v(ii) = diff;
    t_v(ii) = t;
    %%%
    fwritef(1,'diff',diff,'','mae_T2',mae_T2,'','mae_T1',mae_T1,'','t',t,'');
    %%%
end

% if matlabpool('size') > 0
%     matlabpool('close');
% end
save(ite_file, 'diff_v','par_tv','t_v',  'rate_sub_quiz','nnz_sub_quiz','-append');
