function test_predictOneElement()
% test predictOneElement()

% parameters
BETA = 0; 
bag_num_rel = 23;
%coverage = 0.92;
%arg = struct('style','adaptive','aveLen',20,'machine','Pearson');
arg = struct('style','adaptive','aveLen',20,'machine','Homotopy');
%arg = struct('style','static','submatrixSize',[20 20],'machine','Homotopy');


% TestSet = {'Quiz'};
 TestSet = {'Test'};

% load data

% database = 'ua';
% train_quiz_file = getFileName(database,'train','quiz');
% testFile = getFileName(database,'test');
% infFile_train = getFileName(database,'train','inf');%%%
% 
% load(train_quiz_file,'Train','Quiz');
% load(testFile,'Test');
% if strcmpi(arg.machine,'pearson')
%     arg.dataFileInf = infFile_train;
% end

database = 'eachmovie';
train_quiz_file = sprintf('../data/%s_sub.mat',database);
load(train_quiz_file,'Train','Quiz','Test');
%arg.database = database;
arg.predictFile  = '../iteration/NearestNeighbor/predict_nNbr_eachmovie.mat';

rel_dir = ['iteration' filesep 'relatedness'];
for jj = 1:length(TestSet)        
    resultFile = sprintf('../result/relatedness/%s_relDist_%s_%s_%s.txt',...
        database,TestSet{jj},arg.style,arg.machine);
    exampleFile = sprintf('../result/relatedness/%s_badEntry_%s_%s_%s.txt',...
        database,TestSet{jj},arg.style,arg.machine);
    % add the relfile  to file records
    %relFileName = sprintf('ua_rel_%s_%s_%s.mat',TestSet{jj},arg.style,arg.machine);    
    relFileName = sprintf('%s_rel_%s_%s_%s.mat',database,TestSet{jj},...
        arg.style,arg.machine);    
    relFileKey = sprintf('%s_%s_%s_%s',database,TestSet{jj},arg.style,arg.machine);
    addFileRecord({rel_dir,relFileKey,relFileName});
    relFile = getFileName(relFileKey);
    
    fid_result = fopen(resultFile,'w');    
    fid_example = fopen(exampleFile,'w');    
    
    T = eval(TestSet{jj});
    NUM = nnz(T~=BETA);   
    indices=1:NUM;
    informs = struct('grade',cell(NUM,1),'userGrade',BETA,'itemGrade',BETA,'trainSize',[0,0],'nnz',0,'density',0.0,'itemSolutionNorm',BETA,...
        'userSolutionNorm',BETA,'userResidual',BETA,'itemResidual',BETA,'relatedness',BETA,'userRel',[],'itemRel',[],...
        'userLambda',BETA,'itemLambda',BETA,'sizeSubmatrix',[0,0],'iteInf','','densitySubmatrix',BETA);
    rel_v = zeros(NUM,1);
    [II JJ]= find(T~=BETA);
    
    fwritef(1,'number of entries:',NUM,'%d');
    
%     if matlabpool('size') == 0
%         matlabpool open % open pool of matlab sessions for parallelcomputation
%     end
%     fprintf('matlabpool size: %d\n',matlabpool('size'));
    
    %parfor ii = 1:NUM 
    %for ii = 1:NUM     
    %for ii = [1092,  3410,  8779,  8911,  9926,  10275, 10685, 10720,...
    %          10748, 10894, 10910, 10928, 11224, 11269, 11335, 12938,... 
    %          13546, 14427, 4209,  4282,  4229,  4293,  8986, 9536, 10086] 
    for ii = [1092:1092]
    disp(ii);
%         if mod(ii,20)==1         
%             fprintf('\n ===== test point %d\t =====\n',ii);
%         end
        ind = indices(ii);
        grade_test = T(II(ind),JJ(ind));
        [predicted_grade inform]= predictOneElement(train_quiz_file,II(ind),JJ(ind),arg);
        informs(ii) = inform;
        rel_v(ii) = inform.relatedness;
%         if abs(predicted_grade - grade_test)>=3.5
            for fid = [1 fid_example]
                fwritef(fid,'user:',II(ind),'%d\t','item:',JJ(ind),'%d\t');
                fwritef(fid,'grade:',full(grade_test),'%d');
                fwritef(fid,'inform',inform,'');
            end
%         end
    end
%    save(relFile,'II','JJ','indices','informs','rel_v','T','BETA','arg');
    
%     matlabpool close
  
   
    rel_cell = struct2cell(informs);
    rel    = cell2mat(rel_cell(11,:))';
    grade_v  = cell2mat(rel_cell(1,:))';    
    [MAE acc1 acc2 BadEntryRate  ErrorRate MAE_dist  relatedness_dist]= ...
        indicators_index(II(indices),JJ(indices),rel,T,grade_v,BETA,bag_num_rel);
%    printResult();
    
    % Save predicted ratings separately
        % register resultFile and get its name 
    keyStr = sprintf('%s_%s_entropy_result',database,TestSet{jj});
    if isempty(findFileRecord(keyStr))
        addFileRecord({['result' filesep 'entropy'],keyStr,[keyStr '.mat']});
    end
    resultFile_mat = getFileName(keyStr);

    len = length(informs);
    r_v = zeros(len,1);
    for ii=1:len
        r_v(ii) = informs(ii).grade;
    end
%    save(resultFile_mat,'r_v');

end
fclose('all');

    function printResult()
      for id=[1 fid_result]        
        fprintf(id,'%s\n\n',datestr(now));
        fprintf(id,'number of tested entries:\t%d\n',NUM);                
        fprintf(id,'MAE:\t%.3f\tacc1:\t%.2f %%\tacc2:\t%.2f %%\n',MAE,acc1*100,acc2*100);
        fprintf(id,'bad entry rate: %.2f%% \tErrorRate:%.2f%%\n',BadEntryRate*100,ErrorRate*100);
        fprintf(id,'MAE -- # entries:\n');
        fprintf(id,'%.1f\t',MAE_dist(:,1)');
        fprintf(id,'\n');
        fprintf(id,'%d\t',MAE_dist(:,2)');
        fprintf(id,'\n\n');
        fprintf(id,'relatedness -- # entries -- MAE -- ErrorRate:\n');
        fprintf(id,'%.4f\t',relatedness_dist(:,1)');
        fprintf(id,'\n');
        fprintf(id,'%d\t\t',relatedness_dist(:,2)');
        fprintf(id,'\n');
        fprintf(id,'%.2f\t',relatedness_dist(:,3)');
        fprintf(id,'\n');
        fprintf(id,'%.4f\t',relatedness_dist(:,4)');
        fprintf(id,'\n\n');
      end
    end
end
