% test_rel_testset.m
%   calculate the relatedness values on MovieLens and EachMovie with different parameters 

clear

 %====  NOTE that if there exist result file with the same name of ITE_FILE, it will be Replaced! ===   

flag_try = 0;%1; %  % whether have a trying on few (rather than all) elements of each data set
num_try = 40; % work only if flag_try ~=0

% data base
database =  'eachmovie';%'ua'; % %'ua': MovieLens, 'eachmovie': EachMovie 
set_c = {'Quiz','Test'}; % test sets
%set_c = {'Test'}; % test sets

train_quiz_file = getFileName(database,'train','quiz');
fwritef(1,'database',database,'');
   % predict result by Nearest Neighbor
if strcmpi(database,'ua')
    predictFile  = '../iteration/NearestNeighbor/predict_nNbr.mat';
else
    predictFile  = '../iteration/NearestNeighbor/predict_nNbr_eachmovie.mat';
end
load(predictFile,'Predict','BETA');


% load the rating matrix: Train, Quiz, Test
if strcmpi(database,'ua')
     testFile = getFileName(database,'test');
     load(train_quiz_file,'Train','Quiz');
     load(testFile,'Test');
     % make the size of Test the same as Train 
     [ii jj v] = find(Test);  
     sz = size(Train);
     Test = sparse(ii,jj,v,sz(1),sz(2));
else % EachMovie dataset
    load(train_quiz_file,'Train','Quiz','Test');
end

% set the parameters
if strcmpi(database,'ua') %MovieLens dataset
    par_t = struct('n1',  10, 'n2', 120, 'r0', 1.0, 'r1', 0.8,  'r2', 0.6, 'kappa_alpha_coef', 1.0, 'kappa_beta_coef', 1.0 ); 
else % EachMovie dataset
    par_t = struct('n1',  60, 'n2', 160, 'r0', 0.8, 'r1', 0.6,  'r2', 0.4, 'kappa_alpha_coef', 1.0, 'kappa_beta_coef', 1.0 ); 
end
par_t.predictFile = predictFile;
par_t.style = 'adaptive';
par_t.machine = 'Homotopy';


suffix_str = 'newPar';
for k = 1: length(set_c)
    testset  = set_c{k};
    ite_file = sprintf('../iteration/relatedness/%s_rel_%s_%s_%s_%s.mat',database, testset, par_t.style, par_t.machine,suffix_str);
    if strcmpi(testset,'Quiz')
        S = Quiz;
    else
        S = Test;
    end        
    if ~flag_try
        [I, J] = find(S); % get all the indices of nonzero elements
    else % trying to test few user-item pairs
        [I, J] = find(S, num_try); % get all the indices of nonzero elements
    end
    arg = struct('I',I,'J',J,'BETA',BETA);
    %%%
    fprintf('%s on %s set. \n', database, set_c{k});    
    fwritef(1,'#uesr-item pairs:',length(I),'%d');
    %%%
    tic    
        [rel_v grade_v inform_tv]= rel_testset(train_quiz_file,I,J,par_t);
    t = toc;
    save(ite_file, 'par_t','rel_v','grade_v','inform_tv', 'database', 'train_quiz_file','I','J', 'testset','t');        
                            %====  NOTE that if there exist file with the same name, it will be Replaced! ===   
    % evaluate the relatedness metric
    if ~flag_try
        [diff mae_T1 mae_T2]= diff_mae(rel_v,S, Predict, arg);
    else
        sz = size(S);
        ind = sub2ind(sz,I,J);
        Sub = sparse(I,J,S(ind), sz(1),sz(2));        
        [diff mae_T1 mae_T2]= diff_mae(rel_v,Sub, Predict, arg);
    end
    save(ite_file,'diff', 'mae_T1','mae_T2', '-append');    
    %%%
    fwritef(1,'diff',diff,'','mae_T2',mae_T2,'','mae_T1',mae_T1,'','t',t,'');
    %%%
end


