function spyData(A,titleStr,inf,varargin)
% draw the nonzero elements of sparse matrix A
% the second Optional argument is a handle of a text file, where the
%   information of A will be written.

sizeA = size(A);
nnzA = nnz(A); % nonzero elements of A
a = zeros(5,1);
for ii=1:5
    a(ii) = nnz(A==ii);
end

% define a colormap
numColor = 6; % the values consists of A: 0, 1, 2, 3, 4, 5
myMap = ones(numColor,3);
% red = linspace(1,0,numColor-1)';
% blue = 1- red;
% green = ones(numColor-1,1)*0.3;
% myMap(1,:) = [1 1 1]; % define the color corresponding to the value 0 to be (1, 1,1)
% myMap(2:numColor,:) = [red green blue]; % defined the colors corresponding to the values 1--5;

myMap = [1     1     1
         0.7   0     0.1
         0.4   0     0.4
         0.2   0.2   0.2
         0     0.8   0.9  
         0     0     0.9];

% display the matrix A as a map
h1 = imagesc(A);
colormap(myMap);
title(titleStr);
set(gca,'TickLength',[0; 0]);
% text(size(A,2)*0.5,size(A,1)*1.05,inf,'VerticalAlignment','top','HorizontalAlignment','center','FontSize',9);
xlabel(inf);
colorbar('TickLength',[0;0],'YTick',[0:numColor-1]');


% display information of A to screen, and to a text file (if the
% second input argument ) is given
fid = 1;
output(fid); % output the information to screen
if nargin>=4
    fid = varargin{1};
    output(fid); % output the information to the file identified by fid
end
     function output(fid) % output the information to a file identified by fid
        fprintf(fid,'size:\t %d * %d \n',sizeA);
        fprintf(fid,'nonzero elements number:\t%d\n',nnzA );
        fprintf(fid,'nonzero elements density:\t%.4f\n',nnzA/(sizeA(1)*sizeA(2)) );
        fprintf(fid,'nonzero elements distribution:\n');
        fprintf(fid,'%d\t\t',1:5);
        fprintf(fid,'\n');
        fprintf(fid,'%d\t',a);
        fprintf(fid,'\n');
     end
end