% draw the relationship between top-k recommend precision over various relatedness levels

%resultFileKey = 'acc_top_k_recommend_quiz';

dataset = 'eachmovie'; %'ua';%
resultFileKey = sprintf('acc_top_k_recommend_%s_quiz',dataset);
resultFile = getFileName(resultFileKey);

%%setFlag = 1; % setFlag = 1: quiz set; setFlag = 2: test set;
% load result
% % if setFlag == 1
% %     load(resultFile,'num_v_quiz','precision_v_quiz','rel_level'); % rel_level: relatedness level
% %     num_v = num_v_quiz;
% %     precision_v = precision_v_quiz;
% % else
% %     load(resultFile,'num_v_test','precision_v_test','rel_level');
% %     num_v = num_v_test;
% %     precision_v = precision_v_test;
% % end
load(resultFile,'acc_quiz_t');
precision_v = acc_quiz_t(:,:,9); 

len_rel_level = size(precision_v,1); 
modelID_v = [1 2  5 6  8 13]; % 11 14
          % Col 1: SVD
          % Col 2: BellKor
          % Col 5: NNb-user
          % Col 6: NNb-item
          % Col 8: Relatedness
          % Col 9: User-mean
          % Col 10: Item-mean 
          % Col 11: Chaos-0 (total) (ua)
          % Col 12: Chaos-1 (separately) (ua)         
          % Col 13:  DOC
          % On EachMovie dataset, Col11: chaos separately, Col12: chaos
          %   total;
          
nModel = length(modelID_v); 

% draw the precision and relatedness

% % draw lines of accuracy

%color_cell = {'b',[0 1 0],[0.7 0.3 0.1],'r'};
%mark_cell = {'*-','*-','*-','*-'};
% hold on
% for ii = 1:nModel
%     i_model = modelID_v(ii);    
%     plot(1:len_rel_level,precision_v(:,i_model)*100,mark_cell{ii}, 'Color',color_cell{ii} );
% end
% hold off

% h = gca;
% legend(h,{'SVD','BellKor','nNbr','Chaos-round'});
% set(gca,'YLim',[0.8,1.0]*100,'XTickLabel',rel_level,'XTick',1:len_rel_level);
% xlabel('relatedness','FontSize',11);
% ylabel('accuracy(%)','FontSize',11);
% title(h,'top-1 recommend','FontSize',12);
% box on
% grid on

% draw bars
flag_color_bar = 0; % 1: color bars; 0: grey bars
fontsize = 10; 
x_tick_label = {'SVD','BellKor01','nNbr-user','nNbr-item','Rel',...
    'DOC'}; %,'DOC-SVD','DOC-round'};
if flag_color_bar
    color_rel = {[.05 .05 .5],[.6 .05 0]};  % face color of bar for each bag
else
    color_rel = {[.7 .7 .7],[.4 .4 .4]}; % grey bars
end

legend_cell = {'no-rel','use-rel'};
h = bar(100*precision_v(:,modelID_v)',1.5); % bar width = 1.5

% set color for faces of bars
for ii=1:length(color_rel)
    set(h(ii),'FaceColor',color_rel{ii});
end
    
%set(gca,'YLim',[0.75,1.0]*100);
set(gca,'YLim',[0.7,1.0]*100);
ylabel('accuracy (%)','FontSize',fontsize);
legend(h,legend_cell);
%title('top-1 recommend','FontSize',fontsize);

% set the XTicklabel and make it vertical
x_tick = get(gca,'XTick');
y_tick = get(gca,'YTick');
ylim_lb = min(y_tick);
ylim_slice = (max(y_tick)-ylim_lb)/50;
set(gca,'XTickLabel',[]);
h_text = text(x_tick,ylim_lb*ones(size(x_tick))-ylim_slice,x_tick_label,'FontSize',fontsize);
%set(h_text,'Rotation',-90);

% save the figure
figureName_str = ['top_k_acc_' dataset];
if flag_color_bar
    figureName_str = [figureName_str '_color'];
else
    figureName_str = [figureName_str '_grey'];
end
pathStr = [rootpath filesep 'figure' filesep 'top_k_recommend' filesep];
saveas(gcf,[pathStr figureName_str '.fig']);
saveas(gcf,[pathStr figureName_str '.eps'],'psc2');
