% show the relationship between the recommender precision and the
%   relatedness level 

clear;

dataset ='eachmovie'; %'ua'; %

resultFileKey = sprintf('acc_top_k_recommend_%s_quiz',dataset);
if ~existFileRecord(resultFileKey)
    addFileRecord({['result' filesep 'top_k_recommend'] resultFileKey,[resultFileKey '.mat']});
end
resultFile = getFileName(resultFileKey);

pad = '0';

chaosFileKey = sprintf('%s_chaos_pad_%s',dataset,pad);
%chaosFileKey = ['ua_chaos_pad_' pad '_mae_rmse'];
chaosFile = getFileName(chaosFileKey);

%load(chaosFile,'R_test','R_quiz');
load(chaosFile,'R_quiz');
nModel = size(R_quiz,2);

setFlag = 1; % setFlag = 1: quiz set; setFlag = 2: test set;
             % Note that for EachMovie dataset, the R_test set is divided
             % to R_test1, R_test2. Thus, we only do top-k recommendation 
             %  on the quiz set for EachMovie dataset

% load the known entries

if setFlag==1
    %trainFile = sprintf('../data/%s_train_quiz.mat',dataset);
    trainFile = getFileName(sprintf('%s_train_quiz',dataset));
    load(trainFile,'Quiz');
    [user_quiz_v item_quiz_v ] = find(Quiz);
else
    %testFile = sprintf('../data/%s_test.mat',dataset);
    testFile = getFileName(sprintf('%s_test',dataset));
    load(testFile,'Test');
    [user_test_v item_test_v ] = find(Test);
end

% load the relatedness
if setFlag==1
    relFile_quiz = getFileName(sprintf('%s_quiz_adaptive_homotopy',dataset));
    load(relFile_quiz,'rel_v');
    rel_quiz_v = rel_v;
else
    relFile_test = getFileName(sprintf('%s_test_adaptive_homotopy',dataset));
    load(relFile_test,'rel_v');
    rel_test_v = rel_v;
end


% calculate the top-k recommend precision over various relatedness levels
k = 1; % top-k recommendation
rel_level = [0; 3.8];
%%rel_level = [0 3.7 3.75 3.8 3.85  3.9];
       % [0;3.4; 3.60; 3.80; 4.0; 4.2]; % on both ua and eachmovie dataset
       % On quiz set, the white sheep are usr-item pairs with rel >=3.6685
       %  (ua(MovieLens) dataset);
       % On test set, this benchmark is 3.5969 (ua(MovieLens) dataset);
if strcmpi(dataset,'ua')
    goodEntryMark_recommend = 4.0;
else
    goodEntryMark_recommend = 5.0; %4.0;  %5.0; % on Eachmovie dataset; 
                               % it is set as 4.2 on ua dataset; 
end
if strcmpi(dataset,'ua')
    goodEntryMark_acc = 4.0;
else
    goodEntryMark_acc = 5.0; %4.0;  % 5.0 on Eachmovie dataset;  % it is set as 4.0 on ua dataset; 
end
len_rel_level = length(rel_level);
% % num_user_v = zeros(len_rel_level,nModel);
% % num_item_v = zeros(len_rel_level,nModel);
% % precision_v = zeros(len_rel_level,nModel);
% % num_user_comhen_v = zeros(len_rel_level,nModel);
% % num_item_comhen_v = zeros(len_rel_level,nModel);
% % precision_comhen_v = zeros(len_rel_level,nModel);

for i_nModel=nModel:-1:1
    if setFlag==1
        acc_t(:,i_nModel) = cal_precision_rel(Quiz,user_quiz_v,item_quiz_v,...
            R_quiz(:,i_nModel),rel_quiz_v,k,rel_level,goodEntryMark_recommend,goodEntryMark_acc);
        acc_comhen_t(:,i_nModel) = cal_precision_rel(Quiz,user_quiz_v,item_quiz_v,...
            R_quiz(:,i_nModel),rel_quiz_v,k,rel_level,goodEntryMark_recommend,goodEntryMark_acc,1);
    else
         acc_t(:,i_nModel) = cal_precision_rel(Test,user_test_v,item_test_v,...
                R_test(:,i_nModel),rel_test_v,k,rel_level,goodEntryMark_recommend,goodEntryMark_acc);
         acc_comhen_t(:,i_nModel) = cal_precision_rel(Test,user_test_v,item_test_v,...
                R_test(:,i_nModel),rel_test_v,k,rel_level,goodEntryMark_recommend,goodEntryMark_acc,1);
    end
end

% save the result to mat file
items_c = fieldnames(acc_t);
if setFlag == 1    
    acc_quiz_t =  transform_my_struct(acc_t);
    acc_comhen_quiz_t =  transform_my_struct(acc_comhen_t);    
    if exist(resultFile,'file')
        save(resultFile,'items_c','acc_quiz_t','acc_comhen_quiz_t','-append');
    else
        save(resultFile,'items_c','acc_quiz_t','acc_comhen_quiz_t');
    end
else    
    acc_test_t =  transform_my_struct(acc_t);
    acc_comhen_test_t = transform_my_struct(acc_comhen_t);    
    if exist(resultFile,'file')
        save(resultFile,'items_c','acc_test_t','acc_comhen_test_t','-append');
    else
        save(resultFile,'items_c','acc_test_t','acc_comhen_test_t');
    end
end

